package com.adc.da.bs.cloudbackup.dao;

import com.adc.da.bs.cloudbackup.entity.GgData;
import com.adc.da.bs.cloudbackup.entity.GgDataZrin;
import com.adc.da.bs.cloudbackup.entity.GgDatabacs;
import com.adc.da.bs.cloudbackup.entity.GgDatadetail;
import com.adc.da.util.http.PageParam;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.jdbc.core.BatchPreparedStatementSetter;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Component
public class GgDataZrinDao {
	protected final EntityManager entityManager;
    @Autowired
    public GgDataZrinDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }
    @Autowired
    private JdbcTemplate jdbcTemplate;

    /**
     * 分页并按上传日期（降序）显示所有记录
     * @param page
     * @param rkEndTime 
     * @param rkStartTime 
     * @return
     */
    public List<Map<String,Object>> findAllByPage(PageParam page,String cpxh, String pc, String qyid,String confirm,String cpsb, String qrStartTime, String qrEndTime){
    	StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT     to_char(G.CONFIRM_TIME ,'yyyy-MM-DD') as CONFIRM_TIME , to_char(G.CREATE_TIME ,'yyyy-MM-DD') as CREATE_TIME ,G.* ");
    	sql.append(" FROM NERDS.GG_DATA_ZRIN G ");   
    	sql.append(" WHERE G.QY_ID= '"+qyid+"'");   
    	//sql.append(" and ((select count(*) from NERDS.GG_DATA_BACS B WHERE G.ID=B.GG_ID )<1)");   	
    	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND ( CPXH like concat(concat('%',:cpxh),'%') or PC=:cpxh) ");    		
    	}
    	if(cpsb!=null && !"".equals(cpsb)){
        	sql.append(" AND CPSB=:cpsb ");    		
    	}
    	if(pc!=null && !"".equals(pc)){
        	sql.append(" AND PC=:pc ");    		
    	}
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	if(confirm!=null && "0".equals(confirm)){
        	sql.append(" AND (CONFIRM ='0' or CONFIRM is null) ");    		
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND TO_CHAR(G.CREATE_TIME, 'YYYY-MM-DD') >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND TO_CHAR(G.CREATE_TIME, 'YYYY-MM-DD') <=:endTime ");
		} 
		if(qrStartTime!=null && !"".equals(qrStartTime)){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') >=:qrStartTime ");
		}
		if(qrEndTime!=null && !"".equals(qrEndTime)){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') <=:qrEndTime ");
		} 
    	sql.append(" ORDER BY G.CREATE_TIME DESC ");
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("pc", pc);
    	}
    	if(cpsb!=null && !"".equals(cpsb.trim())){
    		query.setParameter("cpsb", cpsb);
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("endTime", page.getEndTime());
		} 
		if(qrStartTime!=null && !"".equals(qrStartTime)){
			query.setParameter("qrStartTime", qrStartTime);
		}
		if(qrEndTime!=null && !"".equals(qrEndTime)){
			query.setParameter("qrEndTime", qrEndTime);
		} 
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
    	query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }
    
    /**
     * 按条件查询出所有的行数
     *
     * @param source  查询文件来源
     * @param qyid 
     * @param rkEndTime 
     * @param rkStartTime 
     * @param name  查询记录标题名称
     * @return
     */
    
    public Long findTotalCount(PageParam page,String cpxh, String pc, String qyid,String confirm,String cpsb, String qrStartTime, String qrEndTime) {
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT COUNT(*) FROM NERDS.GG_DATA_ZRIN G ");
    	sql.append(" WHERE G.QY_ID= '"+qyid+"' ");   
//    	sql.append(" and ((select count(*) from NERDS.GG_DATA_BACS B WHERE G.ID=B.GG_ID )<1)");   		
    	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND ( CPXH like concat(concat('%',:cpxh),'%') or PC=:cpxh) ");    		
    	}
    	if(pc!=null && !"".equals(pc)){
        	sql.append(" AND PC=:pc ");    		
    	}
    	if(cpsb!=null && !"".equals(cpsb)){
        	sql.append(" AND CPSB=:cpsb ");    		
    	}
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	if(confirm!=null && "0".equals(confirm)){
        	sql.append(" AND (CONFIRM ='0' or CONFIRM is null) ");    		
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND TO_CHAR(G.CREATE_TIME, 'YYYY-MM-DD') >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND TO_CHAR(G.CREATE_TIME, 'YYYY-MM-DD') <=:endTime ");
		} 
		if(qrStartTime!=null && !"".equals(qrStartTime)){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') >=:qrStartTime ");
		}
		if(qrEndTime!=null && !"".equals(qrEndTime)){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') <=:qrEndTime ");
		}  
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("pc", pc);
    	}
    	if(cpsb!=null && !"".equals(cpsb.trim())){
    		query.setParameter("cpsb", cpsb);
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("endTime", page.getEndTime());
		} 
		if(qrStartTime!=null && !"".equals(qrStartTime)){
			query.setParameter("qrStartTime", qrStartTime);
		}
		if(qrEndTime!=null && !"".equals(qrEndTime)){
			query.setParameter("qrEndTime", qrEndTime);
		}
    	Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
    }
	/**   
	 * @Title: findIndexBacs   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param cpxh
	 * @param @param pc
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午6:40:16 
	*/   
	public List<Map<String, Object>> findIndexBacs(PageParam page, String cpxh,
			String pc, String qyid ,String confirm) {
    	StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT  G.* ");
    	sql.append(" FROM NERDS.GG_DATA_ZRIN G ");   
    	sql.append(" WHERE G.QY_ID= '"+qyid+"' ");   
    	sql.append("  and ( (select count(*) from NERDS.GG_DATA_BACS B WHERE G.ID=B.GG_ID )>0 )");   
    	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND ( CPXH like concat(concat('%',:cpxh),'%') or PC=:cpxh) ");    		
    	}
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	sql.append(" ORDER BY G.CREATE_TIME DESC ");
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
    	query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}
	/**   
	 * @Title: findIndexBacsCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param cpxh
	 * @param @param pc
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @date 下午6:40:22 
	*/   
	public Long findIndexBacsCount(PageParam page, String cpxh, String pc,
			String qyid,String confirm) {
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT COUNT(*) FROM NERDS.GG_DATA_ZRIN G ");  
    	sql.append(" WHERE G.QY_ID= '"+qyid+"' and ((select count(*) from NERDS.GG_DATA_BACS B WHERE G.ID=B.GG_ID )>0 ) ");   	
    	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND ( CPXH like concat(concat('%',:cpxh),'%') or PC=:cpxh) ");    		
    	}
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	sql.append(" ORDER BY G.CREATE_TIME DESC ");
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
	}

	/**   
	 * @Title: insertggDataZrin   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param ggDataZrin    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 上午11:24:22 
	*/   
	public int insertggDataZrin(GgDataZrin ggDataZrin) {
		int i=0;
    	Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" INSERT INTO NERDS.GG_DATA_ZRIN ");
    	sql.append(" (ID,CPXH,FILETYPE,FILENAME,PC,QY_ID,CREATE_TIME, CPSB, CPMC) VALUES ");
    	sql.append(" (:id, :cpxh,:filetype,:filename,:pc,:qyid,sysdate, :cpsb , :cpmc)");
    	Query query = entityManager.createNativeQuery(sql.toString());
    	query.setParameter("id", ggDataZrin.getId());
    	query.setParameter("cpxh", ggDataZrin.getCpxh());
    	query.setParameter("filetype", ggDataZrin.getFiletype());
    	query.setParameter("filename", ggDataZrin.getFilename());
    	query.setParameter("pc", ggDataZrin.getPc());
    	query.setParameter("qyid", ggDataZrin.getQyid());
    	query.setParameter("cpsb", ggDataZrin.getCpsb());
    	query.setParameter("cpmc", ggDataZrin.getCpmc());
    	i=query.executeUpdate();
    	return i;
    	 
      
	}
	/**   
	 * @Title: insertGgDatadetail   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param ggDatadetail    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 上午11:24:47 
	*/   
	public Map<String,Object>   insertGgDatadetail(GgDatadetail ggDatadetail) {
    	Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" INSERT INTO NERDS.GG_DATA_DETAIL ");
    	sql.append(" (ID,GG_ID,CNAME,ENAME,ITEM_VLAUE,CREATE_TIME) VALUES ");
    	sql.append(" (:id, :ggid,:cname,'',:itemvalue,sysdate)");
    	try {
          Query query = entityManager.createNativeQuery(sql.toString());
          query.setParameter("id", ggDatadetail.getId());
          query.setParameter("ggid", ggDatadetail.getGgId());
          query.setParameter("cname", ggDatadetail.getCname());
          query.setParameter("itemvalue", ggDatadetail.getItemValue());
          if (query.executeUpdate() == 1){
              res.put("success", "1");
              res.put("msg", "保存成功");
          }else{
          	res.put("success", "0");
              res.put("msg", "保存失败");
          }
      } catch (Exception e) {
          res.put("success", "0");
          res.put("msg", e.toString());
          e.printStackTrace();
          System.out.println("---------------------------"+ggDatadetail.getId());
      }
    	
      return res;
	}
	/**   
	 * @Title: insertGgDatabacs   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param ggDatabacs    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 下午5:59:26 
	*/   
	public Map<String,Object> insertGgDatabacs(GgDatabacs ggDatabacs) {
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" INSERT INTO NERDS.GG_DATA_BACS ");
    	sql.append(" (ID, GG_ID, CSBH, CNAME, ENAME, ITEM_VALUE_Q, ITEM_VLAUE_H, CREATE_TIME, CLXH) VALUES ");
    	sql.append(" (:id, :ggid,:csbh, :cname,'',:itemvalueq ,:itemvalueh ,sysdate,'')");
    	try {
          Query query = entityManager.createNativeQuery(sql.toString());
          query.setParameter("id", ggDatabacs.getId());
          query.setParameter("ggid", ggDatabacs.getGgId());
          query.setParameter("csbh", ggDatabacs.getCsbh());
          query.setParameter("cname", ggDatabacs.getCname());
          query.setParameter("itemvalueq", ggDatabacs.getItemValueQ());
          query.setParameter("itemvalueh", ggDatabacs.getItemValueH()); 
          if (query.executeUpdate() == 1){
              res.put("success", "1");
              res.put("msg", "保存成功");
          }else{
        	  res.put("success", "0");
              res.put("msg", "保存失败");
          }
      } catch (Exception e) {
          res.put("success", "0");
          res.put("msg", e.toString());
          e.printStackTrace();
          System.out.println("---------------------------"+ggDatabacs.getId());
      }
    	
      return res;
		
	}
	/**   
	 * @Title: insertlistGgDatadetail   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param listGgDatadetail    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:28:09 
	*/   
	public int  insertlistGgDatadetail(final List<GgDatadetail> listGgDatadetail) {
		int i=0;
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" INSERT INTO NERDS.GG_DATA_DETAIL ");
    	sql.append(" (ID,GG_ID,CNAME,ENAME,ITEM_VLAUE,CREATE_TIME) VALUES ");
    	sql.append(" (?, ?, ?, '', ?,sysdate)");
    	try {
    	int[] ooo= jdbcTemplate.batchUpdate(sql.toString(), new BatchPreparedStatementSetter() {
             public void setValues(PreparedStatement ps, int i) throws SQLException {
            	 GgDatadetail ggDatadetail =listGgDatadetail.get(i);
                 ps.setString(1, ggDatadetail.getId());
                 ps.setString(2, ggDatadetail.getGgId());
                 ps.setString(3, ggDatadetail.getCname());
                 ps.setString(4, ggDatadetail.getItemValue());
             }

			@Override
			public int getBatchSize() {
				// TODO Auto-generated method stub
				return listGgDatadetail.size();
			}
         });
//    	System.out.println(ooo.length);
    	i=ooo.length;  
     } catch (Exception e) { 
         e.printStackTrace();
     }
   	
     return i;
	}

	/**   
	 * @Title: delById   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return String    返回类型   
	 * @author ADC_ZH 
	 * @date 上午9:05:10 
	*/   
	public String delById(String id) {
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql1 = new StringBuffer();
    	sql1.append(" DELETE FROM NERDS.GG_DATA_ZRIN WHERE ID=:id ");
    	StringBuffer sql2 = new StringBuffer();
    	sql2.append(" DELETE FROM NERDS.GG_DATA_DETAIL WHERE GG_ID=:id ");
    	try {
            Query query1 = entityManager.createNativeQuery(sql1.toString());
            query1.setParameter("id", id);
            Query query2 = entityManager.createNativeQuery(sql2.toString());
            query2.setParameter("id", id);
            int ZRIN=query1.executeUpdate();
            int DETAIL=query2.executeUpdate();
            return null;
    	} catch (Exception e) { 
            e.printStackTrace();
            return id;
        }
    	
	}

	/**   
	 * @Title: paramdetail   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:06:36 
	*/   
	public List<Map<String, Object>> paramdetail(String id) {
    	StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT s.SEQ, d.* FROM  NERDS.GG_DATA_DETAIL d ");
    	sql.append(" LEFT JOIN (SELECT seq,CNAME FROM  GGCAIN06.BACSXM WHERE cplb=1  ");
    	sql.append(" UNION  SELECT seq,CNAME FROM  GGCAIN06.GGCSXM WHERE cplb=1) s on s.CNAME=d.CNAME ");
    	sql.append(" WHERE GG_ID=:id ORDER BY d.CNAME  ");
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(id!=null && !"".equals(id.trim())){
    		query.setParameter("id", id);
    	}
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}

	/**   
	 * @Title: bacsdetail   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:06:40 
	*/   
	public List<Map<String, Object>> bacsdetail(String id) {
    	StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT * FROM NERDS.GG_DATA_BACS WHERE GG_ID=:id ");
    	sql.append(" ORDER BY CSBH  ");
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(id!=null && !"".equals(id.trim())){
    		query.setParameter("id", id);
    	}
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}

	/**   
	 * @Title: confirm   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:15:39 
	*/   
    @Modifying
	public int confirm(String id) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" UPDATE NERDS.GG_DATA_ZRIN SET CONFIRM='1',CONFIRM_TIME=SYSDATE  WHERE ID='"+id+"'");
        Query query = entityManager.createNativeQuery(sql.toString()); 
        int ZRIN=query.executeUpdate();
		return ZRIN;
	}

	/**   
	 * @Title: ggEdit   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param ggDatadetail
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:21:35 
	*/   
	public int ggEdit(final List<GgDatadetail> listGgdetail) { 
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" UPDATE NERDS.GG_DATA_DETAIL SET ");
    	sql.append(" ITEM_VLAUE=?, CREATE_TIME=SYSDATE ");
    	sql.append(" WHERE ID=?");
    	sql.append(" AND CNAME NOT IN ('批次','产品型号','产品商标','产品名称')");
    	int ZRIN=0;
    	try {
    		for(GgDatadetail ggDatadetail:listGgdetail){
    			Query query = entityManager.createNativeQuery(sql.toString());
    			query.setParameter(1, ggDatadetail.getItemValue());
    			query.setParameter(2, ggDatadetail.getId());
    			ZRIN+=query.executeUpdate();
    		}
    	
     } catch (Exception e) { 
         e.printStackTrace();
     }
   	
     return ZRIN;
	}

	/**   
	 * @Title: confirmCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @param isc 
	 * @date 下午3:10:28 
	*/   
	public Map<String, Object> confirmCount(String qyid, String isc) {
    	StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT COUNT(*) COU  FROM NERDS.GG_DATA_ZRIN WHERE QY_ID=:qyid ");
    	if(isc!=null && "1".equals(isc)){
    		sql.append(" and confirm ='1' ");
    	}
    	Query query = entityManager.createNativeQuery(sql.toString()); 
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		query.setParameter("qyid", qyid);
		List<Map<String, Object>> list = query.getResultList();
		StringBuffer sql1 = new StringBuffer();
    	sql1.append(" select MAX(TO_NUMBER(NVL(批次,0))) PC from RETRIEVAL.clcp_zk");
    	 
    	Query query1 = entityManager.createNativeQuery(sql1.toString()); 
    	query1.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list2 = query1.getResultList();
		 Map<String, Object> map =new HashMap<>();
		 map.put("COU", list.get(0)==null?"0":list.get(0).get("COU"));
		 map.put("PC", list2.get(0)==null? "0":list2.get(0).get("PC"));
		return map;
	}

	/**   
	 * @Title: backData   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param gg
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @param qyid 
	 * @date 下午9:49:28 
	*/   
	public int backData(GgData gg, String qyid) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" UPDATE NERDS.GG_DATA_ZRIN SET CONFIRM='0', CONFIRM_TIME=''  WHERE cpxh=:cpxh and pc=:pc and cpsb=:cpsb and cpmc=:cpmc and qy_id=:qyid");
    	
        Query query = entityManager.createNativeQuery(sql.toString()); 
		query.setParameter("cpxh", gg.getCpxh());
		query.setParameter("pc", gg.getPc());
		query.setParameter("cpsb", gg.getCpsb());
		query.setParameter("cpmc", gg.getCpmc());
		query.setParameter("qyid", qyid);

        int ZRIN=query.executeUpdate();
		return ZRIN;
	}

}
