package com.adc.da.bs.cloudbackup.rest;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFDataFormatter;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.hibernate.exception.ConstraintViolationException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.adc.da.bs.cloudbackup.entity.GgData;
import com.adc.da.bs.cloudbackup.entity.GgDataZrin;
import com.adc.da.bs.cloudbackup.entity.GgDatabacs;
import com.adc.da.bs.cloudbackup.entity.GgDatadetail;
import com.adc.da.bs.cloudbackup.service.GgDataZrinService;
import com.adc.da.bs.manage.entity.WorkManageEntity;
import com.adc.da.communal.file.store.IFileStore;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.utils.FileUtil;
import com.adc.da.util.utils.IOUtils;


@Controller
@RequestMapping(value = "/${restPath}/ggdataZrin")
@Api(description = "企业私有云")
public class GgDataZrinController {
	private static final String ListGgDatabacs = null;
	@Value("${file.path}")
	private String basePath;//默认路径
    @Autowired
    private IFileStore iFileStore;
    
	@Autowired
	private GgDataZrinService ggDataZrinService;
	
	@ApiOperation(value = "公告参数列表")
    @PostMapping("/findListByPage")
    @ResponseBody
    public Map<String, Object> findListByPage(HttpServletRequest request,PageParam page,String cpxh,String pc,String confirm, String cpsb,String qrStartTime,String qrEndTime) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =ggDataZrinService.findIndex(page,  cpxh,  pc,qyid,confirm,cpsb, qrStartTime, qrEndTime);//首页取15条数据
        return pageMap;
    	
    }
	
	@ApiOperation(value = "公告参数详细")
    @PostMapping("/paramdetail")
    @ResponseBody
    public Map<String, Object> paramdetail(HttpServletRequest request,PageParam page,String id,String type) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =ggDataZrinService.paramdetail(page,  id,  type);
        return pageMap;
    	
    }
	
	@ApiOperation(value = "备案参数列表")
    @PostMapping("/findListByPageBacs")
    @ResponseBody
    public Map<String, Object> findListByPageBacs(HttpServletRequest request,PageParam page,String cpxh,String pc,String confirm) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =ggDataZrinService.findIndexBacs(page,  cpxh,  pc,qyid,confirm);//首页取15条数据
        return pageMap;
    	
    }
	@ApiOperation(value = "删除")
    @PostMapping("/delById")
    @ResponseBody
    public Map<String, Object> delById(HttpServletRequest request,@RequestParam("ids")   String[] ids) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =ggDataZrinService.delById(ids); 
		return usermap;
    	
    }
	@ApiOperation(value = "公告参数编辑")
    @PostMapping("/ggEdit")
    @ResponseBody
    public Map<String, Object> ggEdit(HttpServletRequest request,@RequestBody   List<GgDatadetail> listGgdetail) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =ggDataZrinService.ggEdit(listGgdetail); 
		return pageMap;
    	
    }
	
	@ApiOperation(value = "确认参数")
    @PostMapping("/confirm")
    @ResponseBody
    public Map<String, Object> confirm(HttpServletRequest request,@RequestParam("ids")   String[] ids) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =ggDataZrinService.confirm(ids); 
		return pageMap;
    	
    }
	
	@ApiOperation(value = "确认参数数量")
    @PostMapping("/confirmCount")
    @ResponseBody
    public Map<String, Object> confirmCount(HttpServletRequest request,String  isc) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =ggDataZrinService.confirmCount(qyid,isc); 
		return pageMap;
    	
    }
	
	@ApiOperation(value = "退回参数")
    @PostMapping("/backData")
    @ResponseBody
    public Map<String, Object> backData(HttpServletRequest request,@RequestBody  List<GgData> listGgData) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =ggDataZrinService.backData(listGgData,qyid); 
		return pageMap;
    	
    }
	@ApiOperation(value = "上传公告参数")
    @PostMapping("/addggdataZrin")
    @ResponseBody
    public Map<String, Object> addggdataZrin(HttpServletRequest request, @RequestParam("file") MultipartFile file) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		String cpxh="", pc="",cpmc="",cpsb="";
        Map<String, Object> remap =new HashMap<String, Object>();
        remap.put("success", "0");
        String failxh="";
        InputStream is = null;
        try {
        	String fileExtension = FileUtil.getFileExtension(file.getOriginalFilename());
        	is = file.getInputStream();
        	Sheet sheet = null;
        	if (fileExtension.endsWith("xls")) {
        		Workbook book = new HSSFWorkbook(is);
        		sheet = book.getSheetAt(0);
        	}else if(fileExtension.endsWith("xlsx")){
        		Workbook book = new XSSFWorkbook(is);
        		sheet = book.getSheetAt(0);
        	}else{
        		remap.put("success", "1");
        		remap.put("msg", "保存失败:请上传正确格式文件");
        		return remap;
        	}
        	int row =sheet.getLastRowNum();
        	Row key = sheet.getRow(0);
        	int column=key.getPhysicalNumberOfCells();
        	System.out.println(row);
        	System.out.println(column);
        	for(int i = 1;i<=row;i++){
        		Date date=new Date();
        		List<GgDatadetail> ListGgDatadetail=new ArrayList<>();
        		Row value = sheet.getRow(i);
        		String ggDatazrin_id = UUID.randomUUID().toString().replace("-", "").toLowerCase();
        		for(int c = 0;c<column;c++){
        			GgDatadetail ggDatadetail=new GgDatadetail();
        			String s_key=key.getCell(c)==null?"":key.getCell(c).toString();
        			ggDatadetail.setCname(s_key);
        			String s_value=value.getCell(c)==null?"":value.getCell(c).toString();
        			ggDatadetail.setItemValue(s_value);
        			ggDatadetail.setId(UUID.randomUUID().toString());
        			ggDatadetail.setGgId(ggDatazrin_id);
        			ggDatadetail.setCreatetime(date);
        			ListGgDatadetail.add(ggDatadetail);
        			if("批次".equals(s_key.trim())){
        				pc=value.getCell(c).toString();
        			}
        			if("产品型号".equals(s_key.trim())){
        				cpxh=value.getCell(c).toString();
        			}
        			if("产品商标".equals(s_key.trim())){
        				cpsb=value.getCell(c).toString();
        			}
        			if("产品名称".equals(s_key.trim())){
        				cpmc=value.getCell(c).toString();
        			}
//						System.out.println(c);
        		}
        		int pc_=0;
				try {
					pc_ = (pc==null||"".equals(pc))?0:Double.valueOf(pc).intValue();
				} catch (NumberFormatException e) {
					e.printStackTrace();
				}
        		if(pc_ == 0){
        			remap.put("msg", "批次不能为空且必须为正整数类型");
        			remap.put("success", "1"); 
            		return remap;
        		}
        		if(pc_ < 339&& pc_>0){
        			remap.put("msg", "数据已存在，请确认后重新上传！");
        			remap.put("success", "1"); 
            		return remap;
        		}
        		if("".equals(cpxh)||"".equals(cpmc)){
        			remap.put("msg", "上传数据必须包含“产品型号、产品名称”");
        			remap.put("success", "1"); 
            		return remap;
        		}
        		GgDataZrin ggDataZrin=new GgDataZrin();
        		ggDataZrin.setCpxh(cpxh);
        		ggDataZrin.setId(ggDatazrin_id);
        		ggDataZrin.setPc(String.valueOf(pc_));
        		ggDataZrin.setCreatetime(date);
        		ggDataZrin.setFilename(file.getOriginalFilename());
        		ggDataZrin.setFiletype(fileExtension);
        		ggDataZrin.setQyid(qyid);
        		ggDataZrin.setCpmc(cpmc);
        		ggDataZrin.setCpsb(cpsb);
        		String gg;
				try {
					gg = ggDataZrinService.saveggDataZrin(ggDataZrin,ListGgDatadetail);
				} catch (Exception e) {
					failxh=failxh+cpxh+";";
					remap.put("msg", failxh+e.getMessage());
					 remap.put("success", "1"); 
					 return remap;
				}
        		
        		System.out.println(ggDatazrin_id+"----"+cpxh+"----"+pc);
        		if(gg!=null){
        			remap.put("success", "1");
        			failxh=failxh+gg+";";
        		}
        	}
        	if(failxh!=null&&!"".equals(failxh)){        		
        		remap.put("msg", failxh+"保存失败!!");
        	}
        } catch (IOException e) {
			e.printStackTrace();
    		remap.put("msg", failxh+cpxh+"保存失败!!");
		}finally{
			try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
            
            
             
        
		return remap;
     	
    }
	

	@ApiOperation(value = "上传备案参数")
    @PostMapping("/addggdatabacs")
    @ResponseBody
    public Map<String, Object> addggdatabacs(HttpServletRequest request, @RequestParam("file") MultipartFile file, String ggid) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		String cpxh="", pc="";
		String failxh="";
        Map<String, Object> remap =new HashMap<String, Object>();
        remap.put("success", "0");
        InputStream is = null;
        try {
        	String fileExtension = FileUtil.getFileExtension(file.getOriginalFilename());
        	is = file.getInputStream();
        	Sheet sheet = null;
        	if (fileExtension.endsWith("xls")) {
        		Workbook book = new HSSFWorkbook(is);
        		sheet = book.getSheetAt(0);
        	}else if(fileExtension.endsWith("xlsx")){
        		Workbook book = new XSSFWorkbook(is);
        		sheet = book.getSheetAt(0);
        	}else{
        		remap.put("success", "1");
        		remap.put("msg", "保存失败:请上传正确格式文件");
        		return remap;
        	}
        	int row =sheet.getLastRowNum();
        	Row key = sheet.getRow(0);
        	int column=key.getPhysicalNumberOfCells();
        	System.out.println(row);
        	System.out.println(column);
        	List<GgDatabacs> ListGgDatabacs=new ArrayList<>();
        	for(int i = 1;i<=row;i++){
        		Row value = sheet.getRow(i);
        		Date date=new Date();
        		GgDatabacs ggDatabacs=new GgDatabacs();
        		String ggDatabacs_id = UUID.randomUUID().toString().replace("-", "").toLowerCase();
        		ggDatabacs.setId(ggDatabacs_id);
        		ggDatabacs.setCsbh(value.getCell(0)==null?"":value.getCell(0).toString());
        		ggDatabacs.setCreatetime(date);
        		ggDatabacs.setCname(value.getCell(1)==null?"":value.getCell(1).toString());
        		ggDatabacs.setItemValueQ(value.getCell(2)==null?"":value.getCell(2).toString());
        		ggDatabacs.setItemValueH(value.getCell(3)==null?"":value.getCell(3).toString());
        		ggDatabacs.setGgId(ggid);
        		System.out.println(ggDatabacs_id+"----"+cpxh+"----"+pc);
        		ListGgDatabacs.add(ggDatabacs);
        	}
        	String gg=ggDataZrinService.saveggDatabacs(ListGgDatabacs);
        	if(gg!=null){
    			remap.put("success", "1");
    			failxh=failxh+gg+";";
    			remap.put("msg", "保存失败!!");
    		}
        } catch (IOException e) {
			e.printStackTrace();
		}finally{
			try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return remap;
    }
	
	
	private static String getCellValueByCell(Cell cell) {
		//判断是否为null或空串
		if (cell==null || cell.toString().trim().equals("")) {
			return "";
		}
		String cellValue = "";
		int cellType=cell.getCellType();
		if(cellType==HSSFCell.CELL_TYPE_FORMULA){ //表达式类型
			cellType=cell.getCellType();
		}

		switch (cellType) {
			case HSSFCell.CELL_TYPE_STRING: //字符串类型
				cellValue= cell.getStringCellValue().trim();
				cellValue=StringUtils.isEmpty(cellValue) ? "" : cellValue;
				break;
			case HSSFCell.CELL_TYPE_BOOLEAN:  //布尔类型
				cellValue = String.valueOf(cell.getBooleanCellValue());
				break;
			case HSSFCell.CELL_TYPE_NUMERIC: //数值类型
			 
				HSSFDataFormatter dataFormater = new HSSFDataFormatter();
				cellValue = dataFormater.formatCellValue(cell);
				break;
			default: //其它类型，取空串吧
				cellValue = "";
				break;
		}
		return cellValue;
	}

	 
    //获取流文件
    private static void inputStreamToFile(InputStream ins, File file) {
        try {
            OutputStream os = new FileOutputStream(file);
            int bytesRead = 0;
            byte[] buffer = new byte[8192];
            while ((bytesRead = ins.read(buffer, 0, 8192)) != -1) {
                os.write(buffer, 0, bytesRead);
            }
            os.close();
            ins.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
 
    /**
     * 删除本地临时文件
     * @param file
     */
    public static void delteTempFile(File file) {
    if (file != null) {
        File del = new File(file.toURI());
        del.delete();
    }
    }
}
