package com.adc.da.bs.cloudbackup.rest;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.UUID;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.poi.ss.usermodel.Workbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;

import com.adc.da.bs.cloudbackup.entity.QJTJB;
import com.adc.da.bs.cloudbackup.entity.QJTJB_HistoryINFO;
import com.adc.da.bs.cloudbackup.entity.QJTJB_INFO;
import com.adc.da.bs.cloudbackup.service.QjtjbService;
import com.adc.da.bs.cloudbackup.utils.FileWithExcelUtil;
import com.adc.da.bs.reportManage.rest.ReportManageController;
import com.adc.da.bs.reportManage.utils.PoiUtil;
import com.adc.da.bs.reportManage.utils.ZipUtil;
import com.adc.da.communal.file.store.IFileStore;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.util.utils.FileUtil;


@Controller
@RequestMapping(value = "/${restPath}/qjtjb")
@Api(description = "统计表")
public class QjtjbController {
    private static final Logger logger = LoggerFactory.getLogger(ReportManageController.class);
    private static final String ListGgDatabacs = null;
	@Value("${file.path}")
	private String basePath;//默认路径
    @Autowired
    private IFileStore iFileStore;
    
	@Autowired
	private QjtjbService qjtjbService;
	
	@ApiOperation(value = "统计表列表")
    @PostMapping("/findListByPage")
    @ResponseBody
    public Map<String, Object> findListByPage(HttpServletRequest request,PageParam page,String cpxh,String cpmc,String pc,String confirm, String sblx,String jcejgname,String isnew  ) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =qjtjbService.findIndex(page,  cpxh, cpmc, pc,qyid,confirm,sblx,jcejgname,  isnew  );
        return pageMap;
    }
	
	
	@ApiOperation(value = "历史统计表列表")
    @PostMapping("/findHistoryListByPage")
    @ResponseBody
    public Map<String, Object> findHistoryIndex(HttpServletRequest request,PageParam page,String cpxh,String cpmc,String pc,String confirm, String sblx,String jcejgname,String isnew  ) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =qjtjbService.findHistoryIndex(page,  cpxh, cpmc, pc,qyid,confirm,sblx,jcejgname,  isnew  );
        return pageMap;
    }	
	
	

	@ApiOperation(value = "统计表详细内容")
    @PostMapping("/findQjtjbInfo")
    @ResponseBody
    public Map<String, Object> findQjtjbInfo(HttpServletRequest request, String id,String isNew ) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =qjtjbService.findQjtjbInfo(id,  isNew ,qyid);
        return pageMap;
    }
	
	@ApiOperation(value = "历史统计表详细基本信息")
    @PostMapping("/findHistoryQjtjbBasicInfo")   
    @ResponseBody
    public Map<String, Object> findHistoryQjtjbBasicInfo(HttpServletRequest request, String id,String isNew,String cplb) {
//		isNew ：N--常规统计表   Y--新能源统计表    J--甲醇统计表 
//		cplb = "1"; //TODO  del 
		//处理cplb 
		if(cplb!= null && "Q".equals(cplb.substring(0, 1))){
			cplb = "1";
		}else if(cplb!= null && "M".equals(cplb.substring(0, 1))){
			cplb = "2";
		}else if(cplb!= null && "N".equals(cplb.substring(0, 1))){
			cplb = "3";
		}
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =qjtjbService.findHistoryQjtjbBasicInfo(id,isNew ,qyid,cplb);
        return pageMap;
    }	
	
	@ApiOperation(value = "历史统计表详细内容")
    @PostMapping("/findHistoryQjtjbInfo")
    @ResponseBody
    public Map<String, Object> findHistoryQjtjbInfo(HttpServletRequest request, String id,String isNew,String cplb) {
//		isNew ：N--常规统计表   Y--新能源统计表    J--甲醇统计表 
//		cplb = "1"; //TODO  del 
		//处理cplb 
		if(cplb!= null && "Q".equals(cplb.substring(0, 1))){
			cplb = "1";
		}else if(cplb!= null && "M".equals(cplb.substring(0, 1))){
			cplb = "2";
		}else if(cplb!= null && "N".equals(cplb.substring(0, 1))){
			cplb = "3";
		}
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		Map<String,Object> pageMap =qjtjbService.findHistoryQjtjbInfo(id,isNew ,qyid,cplb);
        return pageMap;
    }	

	
	 /**
	  * 
	  * @Title: uploadQjtjbs   
	  * @Description: TODO(这里用一句话描述这个方法的作用)    
	  * @param @param request
	  * @param @param files
	  * @param @return    设定文件   
	  * @return ResponseMessage    返回类型   
	  * @author ADC_ZH 
	  * @date 上午10:30:28
	  */
    @SuppressWarnings("unchecked")
    @ApiOperation(value = "|Qjtjb|批量统计表上传")
    @PostMapping(value = "/uploadQjtjbs",headers = "content-type=multipart/form-data")
    @ResponseBody
    public ResponseMessage uploadQjtjbs(HttpServletRequest request, @RequestParam("file") MultipartFile[] files) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");

        if (null == usermap || usermap.isEmpty()) {
            return Result.error("请先登录系统后再进行申请.");
        }

        StringBuffer reportSuccess = new StringBuffer("成功上传统计表列表：<br>");
        StringBuffer reportFailure = new StringBuffer("");

        String qyid=usermap.get("USERNAME").toString();
        String qymc=usermap.get("NAME").toString();

        if (null == files || files.length==0) {
            return Result.error("请选择需要批量上传统计表的模板文件.");
        }
        List<QJTJB> tjbEs = new ArrayList<QJTJB>();

        try {
            boolean fileFlg = false;
            String suffix="";
            List<MultipartFile> fileSearched = new ArrayList<>();

            // 获取模板文件
            for (MultipartFile file : files) {

                String fileExtension = FileUtil.getFileExtension(file.getOriginalFilename());
                if (!"xls".equals(fileExtension) && !"xlsx".equals(fileExtension)) {
                    return Result.error("请使.xlsx或者.xls文件上传批量报告.");
                }
            	String name=FileUtil.getFileName(file.getOriginalFilename());
                if ("模板".equals(name)) {
//                	String fileExtension = FileUtil.getFileExtension(file.getOriginalFilename());
                    fileFlg = true;
                    fileSearched.add(file);
                    suffix = fileExtension;
                    break;
                }
            }
            if (fileSearched.size()==0) {
                return Result.error("请使用模板文件上传批量报告.");
            }
            // 读取模板文件
            File importFile = FileUtil.multipartFileToFile(fileSearched.get(0));
            if (importFile != null) {
                suffix = "." + suffix;
                File tempFile = File.createTempFile("temp", suffix);
                tempFile.deleteOnExit();
                FileUtil.copyFile(importFile, tempFile);

                Map<String, List<String>> data = PoiUtil.importExcelTjb(tempFile,2,7);

                Set<String> keySet = data.keySet();
                for (String key : keySet) {
                	System.out.println("++++++++++++++++++++++++++++"+key);
                    if (!"".equals(key)) {
                        List<String> list = data.get(key);
                        QJTJB qjtjb = new QJTJB();
                        System.out.println("list：" + list.toString());
                		String qjtjb_id = UUID.randomUUID().toString().replace("-", "").toLowerCase();
                		qjtjb.setID(qjtjb_id);
                        qjtjb.setCPXH(list.get(0)); 
                        qjtjb.setCPMC(list.get(1));
                        int endIndex =list.get(2).indexOf(".");
                        if (endIndex>=1){
                        	qjtjb.setPC(list.get(2).substring(0,endIndex));
                        }else{
                        	qjtjb.setPC(list.get(2));
                        }
                        qjtjb.setJCEJGNAME(list.get(3));
                        qjtjb.setQJTJB_MC(list.get(4));
                        qjtjb.setQJTJB_NEW_MC(list.get(5)); 
                        qjtjb.setQY_ID(qyid); 
                        System.out.println("文件上传路径：" + PoiUtil.TJB);
                        boolean findReport = false;//普通tjb
                        boolean findReport_new = false;//新能源TJB
                        if(qjtjb.getQJTJB_NEW_MC() ==null || "".equals(qjtjb.getQJTJB_NEW_MC())){
                        	findReport_new=true;
                        }
                        MultipartFile file1 = null;
                        MultipartFile file2 = null;

                        //获取对应报告文件
                        for (MultipartFile file : files) {
//                        	String filename=file.getOriginalFilename();
                        	String filename=FileUtil.getFileName(file.getOriginalFilename());
                            if(qjtjb.getQJTJB_MC().equals(filename)){
                                findReport = true;
                                Long reuslt = qjtjbService.checkTjbStatus(qjtjb.getCPXH(),qjtjb.getPC() ,qyid);
                                if (reuslt>0) {
                                    reportFailure.append ("统计表已存在，无法覆盖和更新报告数据，产品型号：").append (qjtjb.getCPXH()).append ("<br>");
                                    continue;
                                } 
                                file1 = file;

                            } 
                            if(!findReport_new && qjtjb.getQJTJB_NEW_MC().equals(filename)){
                            	findReport_new=true;
                            	Long reuslt = qjtjbService.checkTjbStatus(qjtjb.getCPXH(),qjtjb.getPC() ,qyid);
                                if (reuslt>0) {
                                     continue;
                                } 
                            	file2 = file;
                            	qjtjb.setISNEW("Y");
                            	
                             }
                            
                        }
                        // 报告文件未找到
                        if(!findReport||!findReport_new){
                            reportFailure.append ("上传文件中未找到模板中标记的统计表，产品型号：").append (qjtjb.getCPXH()).append ("<br>");
                        }else{
                            int n = qjtjbService.uploadFile(file1,file2, qjtjb, PoiUtil.TJB);
                            if (0 != n) { 
                                reportSuccess.append (qjtjb.getCPXH()).append ("<br>");
                            }
                        }
                    }
                }
            }
            } catch(Exception e){
                Result.error("批量上传失败，请联系管理员.");
                logger.error(e.getMessage(), e);
                return Result.error("r0072", "文件存储失败，请重试");
            }
        if (reportFailure.length ()>0){ 
            return Result.error(reportFailure.toString ());
        }
        return Result.success(reportSuccess.toString ());
    }
	@ApiOperation(value = "删除")
    @PostMapping("/delById")
    @ResponseBody
    public Map<String, Object> delById(HttpServletRequest request,@RequestParam("ids")   String[] ids) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =qjtjbService.delById(ids); 
		return usermap;
    }
	
	
	@ApiOperation(value = "确认参数")
    @PostMapping("/confirm")
    @ResponseBody
    public Map<String, Object> confirm(HttpServletRequest request,@RequestParam("ids")   String[] ids) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =qjtjbService.confirm(ids); 
		return pageMap;
    	
    }

	@ApiOperation(value = "退回参数")
    @PostMapping("/backData")
    @ResponseBody
    public Map<String, Object> backData(HttpServletRequest request, @RequestParam("ids")   String[] ids) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String,Object> pageMap =qjtjbService.backData(ids,qyid); 
		return pageMap;
    	
    }
	/**
	 * 
	 * @Title: qjtjbInfoEdit   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param request
	 * @param @param listqjtjbInfo
	 * @param @return    设定文件   
	 * @author ADC_ZH 
	 * @date 上午9:25:52
	 */
	@ApiOperation(value = "统计表详细参数编辑")
    @PostMapping("/qjtjbInfoEdit")
    @ResponseBody
    public Map<String, Object> qjtjbInfoEdit(HttpServletRequest request ,@RequestBody List<QJTJB_INFO> listqjtjbInfo) {
      	Map<String,Object> pageMap =qjtjbService.qjtjbInfoEdit(listqjtjbInfo); 
		return pageMap;
    	
    }
	
	
	@ApiOperation(value = "统计表列表编辑")
	@PostMapping("/qjtjbEdit")
    @ResponseBody
    public Map<String, Object> qjtjbEdit(HttpServletRequest request, QJTJB qjtjb, @RequestParam(value="file1",required=false) MultipartFile file1, @RequestParam(value="file2",required=false) MultipartFile file2) {
     	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	if (null != file1) {
			qjtjb.setQJTJB_MC(file1.getOriginalFilename());
 	    }
		if (null != file2){
			qjtjb.setQJTJB_NEW_MC(file2.getOriginalFilename());
		} 
		qjtjb.setQY_ID(qyid);
		Map<String,Object> pageMap =qjtjbService.qjtjbEdit(file1,file2,qjtjb, PoiUtil.TJB); 
		return pageMap;
    }
	
	/**
     * 导出模版
     * @param response
     */
	@ApiOperation(value = "统计表导出")
	@PostMapping("/exportExcel")
	@ResponseBody
    public ResponseMessage export(HttpServletResponse response,HttpServletRequest request, String cpxh ,String id,String isNew ){
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	String title="Y".equals(isNew) ?"新能源统计表":"常规统计表";
    	try {
    		List<QJTJB_INFO> QjtjbInfoList = new ArrayList<>();
    		Map<String,Object> pageMap =qjtjbService.findQjtjbInfo(id,  isNew ,qyid);
    		List<Map<String, Object>> list=(List<Map<String, Object>>) pageMap.get("rows");
    		for(Map<String, Object> map :list ){
    			QJTJB_INFO QJTJBINFO=new QJTJB_INFO();
    			QJTJBINFO.setJcxm(map.get("JCXM")==null?"":map.get("JCXM").toString());
    			QJTJBINFO.setXmdh(map.get("XMDH")==null?"":map.get("XMDH").toString());
    			QJTJBINFO.setJyyj(map.get("JYYJ")==null?"":map.get("JYYJ").toString());
    			QJTJBINFO.setJylb(map.get("JYLB")==null?"":map.get("JYLB").toString());
    			QJTJBINFO.setStid(map.get("STID")==null?"":map.get("STID").toString());
    			QJTJBINFO.setStxh(map.get("STXH")==null?"":map.get("STXH").toString());
    			QJTJBINFO.setStbg(map.get("STBG")==null?"":map.get("STBG").toString());
    			QJTJBINFO.setScxm(map.get("SCXM")==null?"":map.get("SCXM").toString());
    			QJTJBINFO.setScbg(map.get("SCBG")==null?"":map.get("SCBG").toString());
    			QJTJBINFO.setPz(map.get("PZ")==null?"":map.get("PZ").toString());
    			QJTJBINFO.setJyjg(map.get("JYJG")==null?"":map.get("JYJG").toString());
    			QjtjbInfoList.add(QJTJBINFO);
    		}
    		if(QjtjbInfoList.size()<1){
                return Result.error("导出模版失败");
    		}
            //模拟从数据库获取需要导出的数据
            FileWithExcelUtil.exportExcel(QjtjbInfoList,title,cpxh,QJTJB_INFO.class,cpxh+".xls",response);
            return Result.success(("操作成功"));
        } catch (Exception e) {
            logger.info("getCustomerPage", e);
            return Result.error("导出模版失败");
            // TODO: handle exception
        }
      
    }

    @ApiOperation(value = "导出数据模版(判断文件是否存在)")
    @PostMapping("/isExportExcel")
    @ResponseBody
    public Map<String, Object> isExportExcel(HttpServletRequest request, String cpxh ,String id,String isNew ) {
    	Map<String,Object> resultMap = new HashMap<String,Object>();
    	
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	String title="Y".equals(isNew) ?"新能源统计表":"常规统计表";
    	try {
    		List<QJTJB_INFO> QjtjbInfoList = new ArrayList<>();
    		Map<String,Object> pageMap =qjtjbService.findQjtjbInfo(id,  isNew ,qyid);
    		List<Map<String, Object>> list=(List<Map<String, Object>>) pageMap.get("rows");
    		for(Map<String, Object> map :list ){
    			QJTJB_INFO QJTJBINFO=new QJTJB_INFO();
    			QJTJBINFO.setJcxm(map.get("JCXM")==null?"":map.get("JCXM").toString());
    			QJTJBINFO.setXmdh(map.get("XMDH")==null?"":map.get("XMDH").toString());
    			QJTJBINFO.setJyyj(map.get("JYYJ")==null?"":map.get("JYYJ").toString());
    			QJTJBINFO.setJylb(map.get("JYLB")==null?"":map.get("JYLB").toString());
    			QJTJBINFO.setStid(map.get("STID")==null?"":map.get("STID").toString());
    			QJTJBINFO.setStxh(map.get("STXH")==null?"":map.get("STXH").toString());
    			QJTJBINFO.setStbg(map.get("STBG")==null?"":map.get("STBG").toString());
    			QJTJBINFO.setScxm(map.get("SCXM")==null?"":map.get("SCXM").toString());
    			QJTJBINFO.setScbg(map.get("SCBG")==null?"":map.get("SCBG").toString());
    			QJTJBINFO.setPz(map.get("PZ")==null?"":map.get("PZ").toString());
    			QJTJBINFO.setJyjg(map.get("JYJG")==null?"":map.get("JYJG").toString());
    			QjtjbInfoList.add(QJTJBINFO);
    		}
    		if(QjtjbInfoList.size()<1){
    			resultMap.put("result", 0);
    		}else{
    			resultMap.put("result", 1);
    		}
            //模拟从数据库获取需要导出的数据
//            FileWithExcelUtil.exportExcel(QjtjbInfoList,title,cpxh,QJTJB_INFO.class,cpxh+".xls",response);
           // return Result.success(("操作成功"));
        } catch (Exception e) {
            logger.info("getCustomerPage", e);
            resultMap.put("result", 0);
        }
        return resultMap;
    }
	
	
	
	
    @ApiOperation(value = "导出历史数据模版(判断文件是否存在)")
    @PostMapping("/isExportHistoryExcel")
    @ResponseBody
    public Map<String, Object> isExportHistoryExcel(HttpServletRequest request, String cpxh ,String id,String isNew ,String cplb) {
    	Map<String,Object> resultMap = new HashMap<String,Object>();
    	if(cplb!= null && "Q".equals(cplb.substring(0, 1))){
			cplb = "1";
		}else if(cplb!= null && "M".equals(cplb.substring(0, 1))){
			cplb = "2";
		}else if(cplb!= null && "N".equals(cplb.substring(0, 1))){
			cplb = "3";
		}
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	String title="Y".equals(isNew) ?"新能源统计表":"常规统计表";
    	try {
    		List<QJTJB_HistoryINFO> QjtjbInfoList = new ArrayList<>();
    		Map<String,Object> pageMap =qjtjbService.findHistoryQjtjbInfo(id,  isNew ,qyid,cplb);
    		List<Map<String, Object>> list=(List<Map<String, Object>>) pageMap.get("rows");
    		for(Map<String, Object> map :list ){
    			QJTJB_HistoryINFO QJTJBINFO=new QJTJB_HistoryINFO();
    			QJTJBINFO.setSeq(map.get("SEQ")==null?"":map.get("SEQ").toString());
    			QJTJBINFO.setCname(map.get("CNAME")==null?"":map.get("CNAME").toString());
    			QJTJBINFO.setJyyj(map.get("JYYJ")==null?"":map.get("JYYJ").toString());
    			QJTJBINFO.setItem_sqjylb(map.get("ITEM_SQJYLB")==null?"":map.get("ITEM_SQJYLB").toString());
    			QJTJBINFO.setItem_stcpxh(map.get("ITEM_STCPXH")==null?"":map.get("ITEM_STCPXH").toString());
    			
    			String stbgbh ="";
    			List<String> praseBgbh = (List<String>) map.get("ITEM_STBGBH");
    			if(null!=praseBgbh &&  praseBgbh.size()>0){
    				stbgbh = praseBgbh.toString();	
    			}
    			if(stbgbh.contains("[")){
    				stbgbh = stbgbh.replace("[", "").replace("]", "");
    			}
    			QJTJBINFO.setItem_stbgbh(stbgbh);
    			
    			QJTJBINFO.setItem_scxms(map.get("ITEM_SCXMS")==null?"":map.get("ITEM_SCXMS").toString());
    			
    			String scbgbh ="";
    			List<String> bgbh = (List<String>) map.get("ITEM_SCBGBH");
    			if(null!=bgbh &&  bgbh.size()>0){
    				scbgbh = bgbh.toString();	
    			}
    			if(scbgbh.contains("[")){
    				scbgbh = scbgbh.replace("[", "").replace("]", "");
    			}
    			QJTJBINFO.setItem_scbgbh(scbgbh);
    			
    			QJTJBINFO.setItem_jyjg(map.get("ITEM_JYJG")==null?"":map.get("ITEM_JYJG").toString());
    			QJTJBINFO.setXmsm("");
    			QjtjbInfoList.add(QJTJBINFO);
    		}
    		
    		if(QjtjbInfoList.size()<1){
//                return Result.error("导出模版失败");
    			resultMap.put("result", 0);
    		}else{
    			resultMap.put("result", 1);
    		}
            //模拟从数据库获取需要导出的数据
//            FileWithExcelUtil.exportExcel(QjtjbInfoList,title,cpxh,QJTJB_HistoryINFO.class,cpxh+".xls",response);
        } catch (Exception e) {
            logger.info("getCustomerPage", e);
              resultMap.put("result", 0);
        }
        return resultMap;
    }
	
	
	/**
     * 导出历史数据模版
     * @param response
     */
	@ApiOperation(value = "历史统计表导出")
	@PostMapping("/exportHistoryExcel")
	@ResponseBody
    public ResponseMessage exportHistory(HttpServletResponse response,HttpServletRequest request, String cpxh ,String id,String isNew ,String cplb){
		if(cplb!= null && "Q".equals(cplb.substring(0, 1))){
			cplb = "1";
		}else if(cplb!= null && "M".equals(cplb.substring(0, 1))){
			cplb = "2";
		}else if(cplb!= null && "N".equals(cplb.substring(0, 1))){
			cplb = "3";
		}
//		cplb = "1"; //TODO del 
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	String title="Y".equals(isNew) ?"新能源统计表":"常规统计表";
    	try {
    		List<QJTJB_HistoryINFO> QjtjbInfoList = new ArrayList<>();
    		Map<String,Object> pageMap =qjtjbService.findHistoryQjtjbInfo(id,  isNew ,qyid,cplb);
    		List<Map<String, Object>> list=(List<Map<String, Object>>) pageMap.get("rows");
    		for(Map<String, Object> map :list ){
    			QJTJB_HistoryINFO QJTJBINFO=new QJTJB_HistoryINFO();
    			QJTJBINFO.setSeq(map.get("SEQ")==null?"":map.get("SEQ").toString());
    			QJTJBINFO.setCname(map.get("CNAME")==null?"":map.get("CNAME").toString());
    			QJTJBINFO.setJyyj(map.get("JYYJ")==null?"":map.get("JYYJ").toString());
    			QJTJBINFO.setItem_sqjylb(map.get("ITEM_SQJYLB")==null?"":map.get("ITEM_SQJYLB").toString());
    			QJTJBINFO.setItem_stcpxh(map.get("ITEM_STCPXH")==null?"":map.get("ITEM_STCPXH").toString());
    			
    			String stbgbh ="";
    			List<String> praseBgbh = (List<String>) map.get("ITEM_STBGBH");
    			if(null!=praseBgbh &&  praseBgbh.size()>0){
    				stbgbh = praseBgbh.toString();	
    			}
    			if(stbgbh.contains("[")){
    				stbgbh = stbgbh.replace("[", "").replace("]", "");
    			}
    			QJTJBINFO.setItem_stbgbh(stbgbh);
    			
    			QJTJBINFO.setItem_scxms(map.get("ITEM_SCXMS")==null?"":map.get("ITEM_SCXMS").toString());
    			
    			String scbgbh ="";
    			List<String> bgbh = (List<String>) map.get("ITEM_SCBGBH");
    			if(null!=bgbh &&  bgbh.size()>0){
    				scbgbh = bgbh.toString();	
    			}
    			if(scbgbh.contains("[")){
    				scbgbh = scbgbh.replace("[", "").replace("]", "");
    			}
    			QJTJBINFO.setItem_scbgbh(scbgbh);
    			
    			QJTJBINFO.setItem_jyjg(map.get("ITEM_JYJG")==null?"":map.get("ITEM_JYJG").toString());
    			QJTJBINFO.setXmsm("");
    			QjtjbInfoList.add(QJTJBINFO);
    		}
    		if(QjtjbInfoList.size()<1){
                return Result.error("导出模版失败");
    		}
            //模拟从数据库获取需要导出的数据
            FileWithExcelUtil.exportExcel(QjtjbInfoList,title,cpxh,QJTJB_HistoryINFO.class,cpxh+".xls",response);
            return Result.success(("操作成功"));
        } catch (Exception e) {
            logger.info("getCustomerPage", e);
            return Result.error("导出模版失败");
            // TODO: handle exception
        }
      
    }	
	
	
	
	
	@ApiOperation(value = "统计表批量导出")
	@PostMapping("/exportExcelZip")
	@ResponseBody
    public ResponseMessage exportExcelZip(HttpServletResponse response,HttpServletRequest request,@RequestBody List<QJTJB> listqjtjb){
		Date date = new Date();
		//定义一个文件导出存放的路径
        String excelPath=PoiUtil.TJB+date.getTime();
        File savefile = new File(excelPath+"/");
        savefile.mkdirs();
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	try { 
    		for(QJTJB qjtjb:listqjtjb){  
    			
    			String flag = qjtjb.getFLAG();
    			Workbook workbook_n = null;
    			if(null!=flag && "new".equals(flag)){
    				List<QJTJB_INFO> QjtjbInfoList_N = qjtjbInfoList(qjtjb.getID() ,  "N" ,qyid);
        			ExportParams exportParams_n = new ExportParams("常规统计表", qjtjb.getCPXH());
         			workbook_n =ExcelExportUtil.exportExcel(exportParams_n,QJTJB_INFO.class,QjtjbInfoList_N );
    			}
    			if(null!=flag && "history".equals(flag)){
    				List<QJTJB_HistoryINFO> QjtjbInfoList_N = qjtjbHistoryInfoList(qjtjb.getID() ,  "N" ,qyid,qjtjb.getCPLB());
        			ExportParams exportParams_n = new ExportParams("常规统计表", qjtjb.getCPXH());
         			workbook_n =ExcelExportUtil.exportExcel(exportParams_n,QJTJB_HistoryINFO.class,QjtjbInfoList_N );
    			}
     			
                FileOutputStream fos = new FileOutputStream(excelPath+"/常规+"+qjtjb.getCPXH()+"+"+qjtjb.getPC()+".xls");
                try {
                	workbook_n.write(fos);
                    fos.close();
                } catch (Exception e) {
                    e.printStackTrace();
                } 
                
                
     			if("Y".equals(qjtjb.getISNEW())){     				
     				ExportParams exportParams_y = new ExportParams("新能源统计表", qjtjb.getCPXH());
     				Workbook workbook_y =null;
     				
     				if(null!=flag && "new".equals(flag)){
     				List<QJTJB_INFO> QjtjbInfoList_Y = qjtjbInfoList(qjtjb.getID(),  "Y" ,qyid);
     				workbook_y =ExcelExportUtil.exportExcel(exportParams_y,QJTJB_INFO.class,QjtjbInfoList_Y );
     				}
     				
     				if(null!=flag && "history".equals(flag)){
     					List<QJTJB_HistoryINFO> QjtjbInfoList_Y = qjtjbHistoryInfoList(qjtjb.getID(),  "Y" ,qyid,qjtjb.getCPLB());
         				workbook_y =ExcelExportUtil.exportExcel(exportParams_y,QJTJB_HistoryINFO.class,QjtjbInfoList_Y );
     				}
     				
     				FileOutputStream fos2 = new FileOutputStream(excelPath+"/新能源+"+qjtjb.getCPXH()+"+"+qjtjb.getPC()+".xls");
                    try {
                    	workbook_y.write(fos2);
                        fos2.close();
                    } catch (Exception e) {
                        e.printStackTrace();
                    } 
     			}
     		}
    		ZipUtil.zip(excelPath);
            String zipFileName = excelPath+".zip";
            File zipFile = new File(zipFileName);
            BufferedInputStream bins=new BufferedInputStream(new FileInputStream(zipFile));
            response.setCharacterEncoding("UTF-8");
            response.setHeader("content-Type", "application/x-download");
            response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(zipFile.getName(), "UTF-8"));
            ServletOutputStream out1 = null;
            try {
				//这边直接压缩并且在浏览器下载
                out1 = response.getOutputStream();
                int bytesRead = 0;
                byte[] buffer = new byte[8192];
                while ((bytesRead = bins.read(buffer, 0, 8192)) != -1) {
                    out1.write(buffer, 0, bytesRead);
                }
                out1.flush();
                bins.close();
                out1.close();
            } catch (IOException e) {
                e.printStackTrace();
            } 
            return Result.success(("操作成功"));
        } catch (Exception e) {
            logger.info("getCustomerPage", e);
            return Result.error("导出模版失败");
        }
      
    }
	
	public List<QJTJB_INFO> qjtjbInfoList(String id, String isNew ,String qyid){
		List<QJTJB_INFO> QjtjbInfoList = new ArrayList<>();
			Map<String,Object> pageMap =qjtjbService.findQjtjbInfo(id,  isNew ,qyid);
			List<Map<String, Object>> list=(List<Map<String, Object>>) pageMap.get("rows");
			for(Map<String, Object> map :list ){
				QJTJB_INFO QJTJBINFO=new QJTJB_INFO();
				QJTJBINFO.setJcxm(map.get("JCXM")==null?"":map.get("JCXM").toString());
				QJTJBINFO.setXmdh(map.get("XMDH")==null?"":map.get("XMDH").toString());
				QJTJBINFO.setJyyj(map.get("JYYJ")==null?"":map.get("JYYJ").toString());
				QJTJBINFO.setJylb(map.get("JYLB")==null?"":map.get("JYLB").toString());
				QJTJBINFO.setStid(map.get("STID")==null?"":map.get("STID").toString());
				QJTJBINFO.setStxh(map.get("STXH")==null?"":map.get("STXH").toString());
				QJTJBINFO.setStbg(map.get("STBG")==null?"":map.get("STBG").toString());
				QJTJBINFO.setScxm(map.get("SCXM")==null?"":map.get("SCXM").toString());
				QJTJBINFO.setScbg(map.get("SCBG")==null?"":map.get("SCBG").toString());
				QJTJBINFO.setPz(map.get("PZ")==null?"":map.get("PZ").toString());
				QJTJBINFO.setJyjg(map.get("JYJG")==null?"":map.get("JYJG").toString());
				QjtjbInfoList.add(QJTJBINFO);
			}
		return QjtjbInfoList;
		
	}
	
	public List<QJTJB_HistoryINFO> qjtjbHistoryInfoList(String id, String isNew ,String qyid,String cplb){
		if(cplb!= null && "Q".equals(cplb.substring(0, 1))){
			cplb = "1";
		}else if(cplb!= null && "M".equals(cplb.substring(0, 1))){
			cplb = "2";
		}else if(cplb!= null && "N".equals(cplb.substring(0, 1))){
			cplb = "3";
		}
		List<QJTJB_HistoryINFO> QjtjbInfoList = new ArrayList<>();
		Map<String,Object> pageMap =qjtjbService.findHistoryQjtjbInfo(id,  isNew ,qyid,cplb);
		List<Map<String, Object>> list=(List<Map<String, Object>>) pageMap.get("rows");
		for(Map<String, Object> map :list ){
			QJTJB_HistoryINFO QJTJBINFO=new QJTJB_HistoryINFO();
			QJTJBINFO.setSeq(map.get("SEQ")==null?"":map.get("SEQ").toString());
			QJTJBINFO.setCname(map.get("CNAME")==null?"":map.get("CNAME").toString());
			QJTJBINFO.setJyyj(map.get("JYYJ")==null?"":map.get("JYYJ").toString());
			QJTJBINFO.setItem_sqjylb(map.get("ITEM_SQJYLB")==null?"":map.get("ITEM_SQJYLB").toString());
			QJTJBINFO.setItem_stcpxh(map.get("ITEM_STCPXH")==null?"":map.get("ITEM_STCPXH").toString());
			
			String stbgbh ="";
			List<String> praseBgbh = (List<String>) map.get("ITEM_STBGBH");
			if(null!=praseBgbh &&  praseBgbh.size()>0){
				stbgbh = praseBgbh.toString();	
			}
			if(stbgbh.contains("[")){
				stbgbh = stbgbh.replace("[", "").replace("]", "");
			}
			QJTJBINFO.setItem_stbgbh(stbgbh);
			
			QJTJBINFO.setItem_scxms(map.get("ITEM_SCXMS")==null?"":map.get("ITEM_SCXMS").toString());
			
			String scbgbh ="";
			List<String> bgbh = (List<String>) map.get("ITEM_SCBGBH");
			if(null!=bgbh &&  bgbh.size()>0){
				scbgbh = bgbh.toString();	
			}
			if(scbgbh.contains("[")){
				scbgbh = scbgbh.replace("[", "").replace("]", "");
			}
			QJTJBINFO.setItem_scbgbh(scbgbh);
			
			QJTJBINFO.setItem_jyjg(map.get("ITEM_JYJG")==null?"":map.get("ITEM_JYJG").toString());
			QJTJBINFO.setXmsm("");
			QjtjbInfoList.add(QJTJBINFO);
			}
		return QjtjbInfoList;
		
	}	
	
	
	/**
	 * 
	 * @Title: uploadQjtjb   
	 * @Description: 单个上传文件(这里用一句话描述这个方法的作用)    
	 * @param @param request
	 * @param @param files
	 * @param @return    设定文件   
	 * @return ResponseMessage    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:09:35
	 */
   @SuppressWarnings("unchecked")
   @ApiOperation(value = "|Qjtjb|单个统计表上传")
   @PostMapping(value = "/uploadQjtjb")
   @ResponseBody
   public ResponseMessage uploadQjtjb(HttpServletRequest request,  QJTJB qjtjb, @RequestParam(value="file1",required=false) MultipartFile file1, @RequestParam(value="file2",required=false) MultipartFile file2) {
       Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");

       if (null == usermap || usermap.isEmpty()) {
           return Result.error("请先登录系统后再进行申请.");
       }
       StringBuffer reportSuccess = new StringBuffer("成功上传统计表<br>"); 
       String qyid=usermap.get("USERNAME").toString();
       Long reuslt = qjtjbService.checkTjbStatus(qjtjb.getCPXH(),qjtjb.getPC() ,qyid);
       if (reuslt>0) {
           return Result.error(qjtjb.getCPXH()+"统计表已存在,无法覆盖!");       } 
       if (null == file1) {
           return Result.error("请选择需要上传的统计表文件.");
       }
       try {
    	   String fileExtension = FileUtil.getFileExtension(file1.getOriginalFilename());
    	   // 读取模板文件
    	   if("xls".equals(fileExtension) || "xlsx".equals(fileExtension)){
    		   String qjtjb_id = UUID.randomUUID().toString().replace("-", "").toLowerCase();
    		   qjtjb.setID(qjtjb_id); 
    		   qjtjb.setQY_ID(qyid); 
    		   qjtjb.setQJTJB_MC(file1.getOriginalFilename());
    		   if(null != file2){
    			   qjtjb.setQJTJB_NEW_MC(file2.getOriginalFilename());
    		   }
    		   int n = qjtjbService.uploadFile(file1,file2, qjtjb, PoiUtil.TJB);
    		   if (0 != n) { 
    			   reportSuccess.append (qjtjb.getCPXH()).append ("<br>");
    		   }else{
                   return Result.error("文件存储失败，请重试");
    		   }
    	   }else{
    			throw new AdcDaBaseException("请上传正确的统计表文件");
    	   } 
        }catch(Exception e){ 
               logger.error(e.getMessage(), e);
               return Result.error("r0072", "文件存储失败，请重试");
        } 
       return Result.success(reportSuccess.toString ());
   }
   
   /**
    * 
    * @Title: pc   
    * @Description: 批次列表 
    * @param @param request
    * @param @return    设定文件    
    * @author ADC_ZH 
    * @date 下午4:39:27
    */
	@ApiOperation(value = "批次列表")
    @PostMapping("/pc")
    @ResponseBody
    public Map<String, Object> pc(HttpServletRequest request) {
      	Map<String,Object> pageMap =qjtjbService.pc(); 
		return pageMap; 
    }
	
	@ApiOperation(value = "批次列表")
    @PostMapping("/historypc")
    @ResponseBody
    public Map<String, Object> oldpc(HttpServletRequest request) {
      	Map<String,Object> pageMap =qjtjbService.oldpc(); 
		return pageMap; 
    }
	
	 
}
