package com.adc.da.bs.cloudbackup.service;

import java.sql.SQLIntegrityConstraintViolationException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.hibernate.exception.ConstraintViolationException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.adc.da.bs.cloudbackup.dao.GgDataZrinDao;
import com.adc.da.bs.cloudbackup.entity.GgData;
import com.adc.da.bs.cloudbackup.entity.GgDataZrin;
import com.adc.da.bs.cloudbackup.entity.GgDatabacs;
import com.adc.da.bs.cloudbackup.entity.GgDatadetail;
import com.adc.da.bs.cloudbackup.utils.UserException;
import com.adc.da.bs.manage.dao.PolicyManageDao;
import com.adc.da.bs.manage.entity.PolicyManageEntity;
import com.adc.da.util.http.PageParam;
/**
 * 4.4.2.	政策解读管理
 * @author LuZhiPeng
 *
 */

@Service
public class GgDataZrinService {
	@Autowired
	private GgDataZrinDao ggDataZrinDao;
	
/**
 * 条目索引分页	
 * @param page
 * @param qyid 
 * @param pc 
 * @param cpxh 
 * @param rkEndTime 
 * @param rkStartTime 
 * @return
 */
	public Map<String, Object> findIndex(PageParam page, String cpxh, String pc, String qyid,String confirm,String cpsb, String qrStartTime, String qrEndTime){
		Map<String, Object> result = new HashMap<>();
		Long count = ggDataZrinDao.findTotalCount(page, cpxh, pc,qyid,confirm,cpsb, qrStartTime, qrEndTime);
		List<Map<String, Object>> list = ggDataZrinDao.findAllByPage(page , cpxh,  pc,qyid,confirm,cpsb, qrStartTime, qrEndTime);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
	/**   
	 * @Title: findIndexBacs   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param cpxh
	 * @param @param pc
	 * @param @param qyid
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午6:39:14 
	*/   
	public Map<String, Object> findIndexBacs(PageParam page, String cpxh,
			String pc, String qyid,String confirm) {
		Map<String, Object> result = new HashMap<>();
		Long count = ggDataZrinDao.findIndexBacsCount(page, cpxh, pc,qyid,confirm);
		List<Map<String, Object>> list = ggDataZrinDao.findIndexBacs(page , cpxh,  pc,qyid,confirm);
		result.put("total", count);
		result.put("rows", list);
		return result;
	}
	/**
	 * 条件查询并分页
	 * @param page
	 * @param source
	 * @param name
	 * @return
	 *//*
	public Map<String, Object> findWorkList(PageParam page,String source, String title) {
		Map<String, Object> result = new HashMap<>();
		Long count = policyManageDao.findTotalCount(page, source, title);
		List<Map<String, Object>> list = policyManageDao.findListByPage(page, source, title);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
	*//**
	 * 添加
	 * @param policyManageEntity
	 * @return
	 *//*
	@Transactional
	public Map<String,Object> addWork(PolicyManageEntity policyManageEntity){
		Map<String, Object> result = policyManageDao.insertWork(policyManageEntity);
		return result;
	}
	@Transactional
	public boolean changeViewCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=policyManageDao.changeViewCountById(id);
		return i;
	}
	@Transactional
	public boolean changeDownloadCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=policyManageDao.changeDownloadCountById(id);
		return i;
	}
	@Transactional
	public boolean deleteWork(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=policyManageDao.deleteWork(id);
		return i;
	}*/

/**   
 * @Title: saveggDataZrin   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param ggDataZrin
 * @param @return    设定文件   
 * @return String    返回类型   
 * @author ADC_ZH 
 * @param listGgDatadetail 
 * @date 上午11:18:33 
*/   
@Transactional
public String saveggDataZrin(GgDataZrin ggDataZrin, List<GgDatadetail> listGgDatadetail)  throws UserException   {
	try {
		int result =ggDataZrinDao.insertggDataZrin(ggDataZrin);
		int result2 =ggDataZrinDao.insertlistGgDatadetail(listGgDatadetail);
		if(result==1&&result2==listGgDatadetail.size()){
			return null;
		}else{
			return ggDataZrin.getCpxh();
		}
	} catch (Exception e) { 
		if(e.getCause() instanceof ConstraintViolationException) { 
			throw new UserException("（不能上传重复车型）");
		}
		return ggDataZrin.getCpxh();
	}
 	
}

/**   
 * @Title: saveggDatabacs   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param listGgDatabacs
 * @param @return    设定文件   
 * @return String    返回类型   
 * @author ADC_ZH 
 * @date 下午5:51:19 
*/   
@Transactional
public String saveggDatabacs(List<GgDatabacs> listGgDatabacs) {
	for(GgDatabacs ggDatabacs : listGgDatabacs){
		Map<String, Object> result = ggDataZrinDao.insertGgDatabacs(ggDatabacs);
	}
	return null;
}
/**   
 * @Title: delById   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param ids
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @date 上午9:04:11 
*/      
@Transactional
public Map<String, Object> delById(String[]  ids) {
	for(String id : ids){
		String result =ggDataZrinDao.delById(id);
		System.out.println(id);
	}
	return null;
}
/**   
 * @Title: paramdetail   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param page
 * @param @param id
 * @param @param type
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @date 下午2:03:21 
*/   
public Map<String, Object> paramdetail(PageParam page, String id, String type) {
	Map<String, Object> result = new HashMap<>();
	List<Map<String, Object>> paramdetail= ggDataZrinDao.paramdetail(id);
	if("2".equals(type)){
		List<Map<String, Object>> bacsdetail = ggDataZrinDao.bacsdetail(id);
		result.put("bacsdetail", bacsdetail); 
	}
	result.put("paramdetail", paramdetail); 
	return result;
}
/**   
 * @Title: confirm   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param ids
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @date 下午1:56:20 
*/   
@Transactional
public Map<String, Object> confirm(String[] ids) {
	String reid="";
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	for(String id : ids){
		int re =ggDataZrinDao.confirm(id);
		if(re==0){
			result.put("result", 1); 
			result.put("error", reid+id+";确认失败！"); 
		}
	}
	
	return result;
}
/**   
 * @Title: ggEdit   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param listGgdetail
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @date 上午11:13:09 
*/ 
@Transactional  
public Map<String, Object> ggEdit(List<GgDatadetail> listGgdetail) {
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	int re =ggDataZrinDao.ggEdit(listGgdetail);
	if(re<listGgdetail.size()){
		result.put("result", 1); 
		result.put("error", "修改失败！"); 
	} 
	return result;
}
/**   
 * @Title: confirmCount   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param qyid
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @param isc 
 * @date 下午3:08:46 
*/   
public Map<String, Object> confirmCount(String qyid, String isc) {
	Map<String, Object> result = new HashMap<>();
	result= ggDataZrinDao.confirmCount(qyid,isc); 

	return result;
}
/**   
 * @Title: backData   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param listGgData
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @param qyid 
 * @date 下午9:42:28 
*/   
@Transactional  
public Map<String, Object> backData(List<GgData> listGgData, String qyid) {
	String reid="";
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	for(GgData gg : listGgData){
		int re =ggDataZrinDao.backData(gg,qyid);
		if(re==0){
			result.put("result", 1); 
			result.put("error", reid+gg.getCpxh()+";退回失败！未找到上传备案参数"); 
		}
	}
	
	return result;
}


}
