package com.adc.da.bs.cloudbackup.service;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.UUID;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import com.adc.da.bs.cloudbackup.dao.QjtjbDao;
import com.adc.da.bs.cloudbackup.entity.QJTJB;
import com.adc.da.bs.cloudbackup.entity.QJTJB_INFO;
import com.adc.da.bs.reportManage.utils.PoiUtil;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.utils.FileUtil;
 

@Service
public class QjtjbService {
	@Autowired
	private QjtjbDao qjtjbDao;
	
/**
 * 条目索引分页	
 * @param page
 * @param qyid 
 * @param pc 
 * @param cpxh 
 * @param rkEndTime 
 * @param rkStartTime 
 * @return
 */
	public Map<String, Object> findIndex(PageParam page, String cpxh,String cpmc, String pc, String qyid,String confirm,String sblb, String jcejg,String isnew ){
		Map<String, Object> result = new HashMap<>();
		Long count = qjtjbDao.findTotalCount(page, cpxh, cpmc,  pc,qyid,confirm,sblb,  jcejg,  isnew );
		List<Map<String, Object>> list = qjtjbDao.findAllByPage(page , cpxh, cpmc,   pc,qyid,confirm,sblb,  jcejg,  isnew );
		result.put("total", count);
		result.put("rows", list);
		return result;
	}

	public Map<String, Object> findHistoryIndex(PageParam page, String cpxh,String cpmc, String pc, String qyid,String confirm,String sblb, String jcejg,String isnew ){
		Map<String, Object> result = new HashMap<>();
		Long count = qjtjbDao.findHistoryTotalCount(page, cpxh, cpmc,  pc,qyid,confirm,sblb,  jcejg,  isnew );
		List<Map<String, Object>> list = qjtjbDao.findHistoryAllByPage(page , cpxh, cpmc,   pc,qyid,confirm,sblb,  jcejg,  isnew );
		result.put("total", count);
		result.put("rows", list);
		return result;
	}
	

/**   
 * @Title: checkTjbStatus   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param cpxh
 * @param @return    设定文件   
 * @return List<String>    返回类型   
 * @author ADC_ZH 
 * @date 下午4:53:43 
*/   
public Long checkTjbStatus(String cpxh,String pc ,String qyid) {
	Long count = qjtjbDao.checkTjbStatus(cpxh, pc ,qyid);
	return count;
}

/**   
 * @Title: uploadFile   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param file1
 * @param @param file2
 * @param @param qjtjb
 * @param @param address
 * @param @return    设定文件   
 * @return int    返回类型   
 * @author ADC_ZH 
 * @date 下午5:05:03 
*/   
@Transactional  
public int uploadFile(MultipartFile file1, MultipartFile file2, QJTJB qjtjb,
		String address) {
	List<QJTJB_INFO> qjtjbinfo1;
	try {
		qjtjbinfo1 = ExcelBunk(file1,2,13,qjtjb );
		if(qjtjbinfo1.isEmpty()){	
			throw new AdcDaBaseException("统计表内容不能为空");
		}
		qjtjbDao.insertQjtjbInfo(qjtjbinfo1,"N");
		if(file2!=null && !file2.isEmpty()){			
//		List<QJTJB_INFO> qjtjbinfo2=importFile(file2,qjtjb,address);
			List<QJTJB_INFO> qjtjbinfo2=ExcelBunk(file2,2,13,qjtjb );
			if(!file2.isEmpty()&&!qjtjbinfo2.isEmpty()){		
				qjtjbDao.insertQjtjbInfo(qjtjbinfo2,"Y");
			}
		}
		qjtjbDao.insertQjtjb(qjtjb); 
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		return 0;
	}
	return 1;
}
   
public List<QJTJB_INFO> importFile(MultipartFile file , QJTJB qjtjb,String address) {
    List<QJTJB_INFO> tjbEs = new ArrayList<QJTJB_INFO>();

	if (null != file) {
        //判断目标路径是否存在
        File fileUpload = new File(address);
        if (!fileUpload.exists()) {
            //不存在 创建目录
            fileUpload.mkdirs();
        }
        System.out.println("文件名称：" + file.getOriginalFilename());
        //创建上传文件对象（文件存储的路径，文件名称）
        fileUpload = new File(address, file.getOriginalFilename());

        //将文件写入到服务器中
        try {
			file.transferTo(fileUpload);
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        // 读取模板文件
        File importFile;
        try {
        	importFile = FileUtil.multipartFileToFile(file);
        	if (importFile != null) {
        		String fileExtension = FileUtil.getFileExtension(file.getOriginalFilename());
        		if ("xls".equals(fileExtension) || "xlsx".equals(fileExtension)) {
        			File tempFile = File.createTempFile("temp", "."+fileExtension);
        			tempFile.deleteOnExit();
        			FileUtil.copyFile(importFile, tempFile);
        			Map<String, List<String>> data = PoiUtil.importExcelTjb(tempFile,2,13);
        			Set<String> keySet = data.keySet();
        			for (String key : keySet) {
        				if (!"".equals(key)) {
        					QJTJB_INFO qjtjbinfo = new QJTJB_INFO();
        					List<String> list = data.get(key);
        					System.out.println("list：" + list.toString());
        					String id = UUID.randomUUID().toString().replace("-", "").toLowerCase();
        					qjtjbinfo.setId(id);
        					qjtjbinfo.setQjtjbid(qjtjb.getID());
        					qjtjbinfo.setXmdh(list.get(0));
        					qjtjbinfo.setJcxm(list.get(1));
        					qjtjbinfo.setJyyj(list.get(2));
        					qjtjbinfo.setJylb(list.get(3));
        					qjtjbinfo.setStid(list.get(4));
        					qjtjbinfo.setStxh(list.get(5));
        					qjtjbinfo.setStbg(list.get(6));
        					qjtjbinfo.setScxm(list.get(7));
        					qjtjbinfo.setScbg(list.get(8));
        					qjtjbinfo.setPz(list.get(9));
        					qjtjbinfo.setJyjg(list.get(10));
        					qjtjbinfo.setXmsm(list.get(11)); 
        					qjtjbinfo.setQY_ID(qjtjb.getQY_ID());  
        					tjbEs.add(qjtjbinfo);
        				}
        			}
        		}
        	}
        } catch (Exception e) {
        	// TODO Auto-generated catch block
        	e.printStackTrace();
        }
        
     }
	return tjbEs;
}

 
 
public List<QJTJB_INFO> ExcelBunk(MultipartFile file, int beginrow, int column, QJTJB qjtjb) throws Exception {
	List<QJTJB_INFO> list=new ArrayList<>();
    try {
        /**
         *
         * 判断文件版本
         */
        String fileName = file.getOriginalFilename();
        String suffix = fileName.substring(fileName.lastIndexOf(".") + 1);

        InputStream ins = file.getInputStream();

        Workbook wb = null;

        if (suffix.equals("xlsx")) {
            wb = new XSSFWorkbook(ins);
        } else {
            wb = new HSSFWorkbook(ins);
        }
        /**
         * 获取excel表单
         */
        Sheet sheet = wb.getSheetAt(0);
        List<CellRangeAddress> combineCell = getCombineCell(sheet);
        System.out.println("表格共:"+sheet.getLastRowNum()+"行");
        if (null != sheet) {
            for (int line = beginrow; line <= sheet.getLastRowNum(); line++) {
                Row row = sheet.getRow(line);
                if (null == row) {
                    continue;
                }
                List<String> listS=new ArrayList<>();
                //接收值取到的值
                for(int c=1; c <  column; c++){
                	String stg=""; //获取到的值
                	String cellValue = getCellValue(row.getCell(c));  
                	if (cellValue != null) { 
                		if (isMergedRegion(sheet, line, c) == true) {
                			stg = isCombineCell(combineCell, row.getCell(c), sheet);
                		} else {
                			Cell cell = row.getCell(c);
                			stg = getCellValue(cell);
                		}
                		System.out.println(line+"行"+c+"列："+stg);
                	}else if (isMergedRegion(sheet, line, c) ) {
                		//判断是不是合并的单元格
                		boolean flag=true;
                		int i=1;
                		while(flag){                			
                			Row row_last = sheet.getRow(line-i);
                			if(row_last.getCell(c)!=null){                				
                				Cell cell1=row_last.getCell(c);   
                				stg = isCombineCell(combineCell, cell1, sheet);
                				flag=false;
                			}else{
                				i=i+1;
                			}
                		}
                	} 
            		listS.add(stg);
                }
                QJTJB_INFO qjtjbinfo = new QJTJB_INFO();   
				String id = UUID.randomUUID().toString().replace("-", "").toLowerCase();
				qjtjbinfo.setId(id);
				qjtjbinfo.setQjtjbid(qjtjb.getID());
				qjtjbinfo.setXmdh(listS.get(0));
				qjtjbinfo.setJcxm(listS.get(1));
				qjtjbinfo.setJyyj(listS.get(2));
				qjtjbinfo.setJylb(listS.get(3));
				qjtjbinfo.setStid(listS.get(4));
				qjtjbinfo.setStxh(listS.get(5));
				qjtjbinfo.setStbg(listS.get(6));
				qjtjbinfo.setScxm(listS.get(7));
				qjtjbinfo.setScbg(listS.get(8));
				qjtjbinfo.setPz(listS.get(9));
				qjtjbinfo.setJyjg(listS.get(10));
				qjtjbinfo.setXmsm(listS.get(11)); 
				qjtjbinfo.setQY_ID(qjtjb.getQY_ID());  
				list.add(qjtjbinfo);
            }
        }
    } catch (Exception e) {
        e.printStackTrace();
    }
    return list;
} 
/**
 * 判断指定的单元格是否是合并单元格
 *
 * @param sheet
 * @param row    行下标
 * @param column 列下标
 * @return
 */
private boolean isMergedRegion(Sheet sheet, int row, int column) {
    int sheetMergeCount = sheet.getNumMergedRegions();
    for (int i = 0; i < sheetMergeCount; i++) {
        CellRangeAddress range = sheet.getMergedRegion(i);
        int firstColumn = range.getFirstColumn();
        int lastColumn = range.getLastColumn();
        int firstRow = range.getFirstRow();
        int lastRow = range.getLastRow();
        if (row >= firstRow && row <= lastRow) {
            if (column >= firstColumn && column <= lastColumn) {
                return true;
            }
        }
    }
    return false;
}
public static String getMergedRegionValue(Sheet sheet ,int row , int column){
    int sheetMergeCount = sheet.getNumMergedRegions();    
    for(int i = 0 ; i < sheetMergeCount ; i++){    
        CellRangeAddress ca = sheet.getMergedRegion(i);    
        int firstColumn = ca.getFirstColumn();    
        int lastColumn = ca.getLastColumn();    
        int firstRow = ca.getFirstRow();    
        int lastRow = ca.getLastRow();    
        if(row >= firstRow && row <= lastRow){    
            if(column >= firstColumn && column <= lastColumn){    
                Row fRow = sheet.getRow(firstRow);    
                Cell fCell = fRow.getCell(firstColumn);    
                return getCellValue(fCell) ;    
            }    
        }    
    }
    return null ;    
}    
 
/**
 * 判断单元格是否为合并单元格，是的话则将单元格的值返回
 *
 * @param listCombineCell 存放合并单元格的list
 * @param cell            需要判断的单元格
 * @param sheet           sheet
 * @return
 */
public String isCombineCell(List<CellRangeAddress> listCombineCell, Cell cell, Sheet sheet)
        throws Exception {
    int firstC = 0;
    int lastC = 0;
    int firstR = 0;
    int lastR = 0;
    String cellValue = null;
    for (CellRangeAddress ca : listCombineCell) {
        //获得合并单元格的起始行, 结束行, 起始列, 结束列
        firstC = ca.getFirstColumn();
        lastC = ca.getLastColumn();
        firstR = ca.getFirstRow();
        lastR = ca.getLastRow();
        if (cell.getRowIndex() >= firstR && cell.getRowIndex() <= lastR) {
            if (cell.getColumnIndex() >= firstC && cell.getColumnIndex() <= lastC) {
                Row fRow = sheet.getRow(firstR);
                Cell fCell = fRow.getCell(firstC);
                cellValue = getCellValue(fCell);
                break;
            }
        } else {
            cellValue = "";
        }
    }
    return cellValue;
}

/**
 * 合并单元格处理,获取合并行
 *
 * @param sheet
 * @return List<CellRangeAddress>
 */
public List<CellRangeAddress> getCombineCell(Sheet sheet) {
    List<CellRangeAddress> list = new ArrayList<>();
    //获得一个 sheet 中合并单元格的数量
    int sheetmergerCount = sheet.getNumMergedRegions();
    //遍历所有的合并单元格
    for (int i = 0; i < sheetmergerCount; i++) {
        //获得合并单元格保存进list中
        CellRangeAddress ca = sheet.getMergedRegion(i);
        list.add(ca);
    }
    return list;
}

/**
 * 获取单元格的值（获取不同类型，都返回String）
 *
 * @param cell
 * @return
 */
private static String getCellValue(Cell cell) {
    String st = null;
    if (cell == null || cell.equals("")) {
        st = null;
    } else if (cell.getCellType() == Cell.CELL_TYPE_FORMULA) {
        //公式
        st = cell.getStringCellValue();
    } else if (cell.getCellType() == Cell.CELL_TYPE_NUMERIC) {
        //数值型
        st = cell.getNumericCellValue() + "";
        st = st.substring(0, st.lastIndexOf("."));
    } else if (cell.getCellType() == Cell.CELL_TYPE_STRING) {
        //字符串型
        st = cell.getStringCellValue();
    } else if (cell.getCellType() == Cell.CELL_TYPE_BLANK) {
        //空值
        st = cell.getStringCellValue();
    }
    return st;
} 


/**   
 * @Title: delById   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param ids
 * @param @return    设定文件    
 * @author ADC_ZH 
 * @date 下午1:52:54 
*/   
@Transactional
public Map<String, Object> delById(String[] ids) {
	for(String id : ids){
		String result =qjtjbDao.delById(id);
		System.out.println(id);
	}
	return null;
}

/**   
 * @Title: confirm   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param ids
 * @param @return    设定文件   
 *    返回类型   
 * @author ADC_ZH 
 * @date 下午1:57:24 
*/   
@Transactional
public Map<String, Object> confirm(String[] ids) {
	String reid="";
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	for(String id : ids){
		int re =qjtjbDao.confirm(id);
		if(re==0){
			result.put("result", 1); 
			result.put("error", reid+id+";确认失败！"); 
		}
	}
	return result;
}

/**   
 * @Title: pc   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @return    设定文件   
 *    返回类型   
 * @author ADC_ZH 
 * @date 下午4:39:15 
*/   
public Map<String, Object> pc() {
	Map<String, Object> result = new HashMap<>();
	List<Map<String, Object>> rows= qjtjbDao.pc(); 
	result.put("result", 0); 
	result.put("rows", rows); 
	return result;
}

public Map<String, Object> oldpc() {
	Map<String, Object> result = new HashMap<>();
	List<Map<String, Object>> rows= qjtjbDao.oldpc(); 
	result.put("result", 0); 
	result.put("rows", rows); 
	return result;
}

/**   
 * @Title: findQjtjbInfo   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param id
 * @param @param isNew
 * @param @return    设定文件   
 *    返回类型   
 * @author ADC_ZH 
 * @date 下午5:02:02 
*/   
public Map<String, Object> findQjtjbInfo(String id, String isNew,String qyid) {
	Map<String, Object> result = new HashMap<>();
	Long count = qjtjbDao.findQjtjbInfoCount(id, isNew,qyid);
	List<Map<String, Object>> list = qjtjbDao.findQjtjbInfo(id, isNew,qyid);
	result.put("total", count);
	result.put("rows", list); 
	return result;
}

public Map<String, Object> findHistoryQjtjbInfo(String id, String isNew,String qyid,String cplb) {
	Map<String, Object> result = new HashMap<>();
	Long count = qjtjbDao.findHistoryQjtjbInfoCount(id, isNew,qyid,cplb);
	List<Map<String, Object>> list = qjtjbDao.findHistoryQjtjbInfo(id, isNew,qyid,cplb);
	result.put("total", count);
	result.put("rows", list); 
	return result;
}

public Map<String, Object> findHistoryQjtjbBasicInfo(String id, String isNew,String qyid,String cplb) {
	Map<String, Object> result = new HashMap<>();
	List<Map<String, Object>> rows= qjtjbDao.findHistoryQjtjbBasicInfo(id); 
	result.put("result", 0); 
	result.put("rows", rows); 
	return result;
}


/**   
 * @Title: qjtjbInfoEdit   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param listqjtjbInfo
 * @param @return    设定文件   
 *    返回类型   
 * @author ADC_ZH 
 * @date 上午8:53:37 
*/   
@Transactional
public Map<String, Object> qjtjbInfoEdit(List<QJTJB_INFO> listqjtjbInfo) {
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	int re =qjtjbDao.qjtjbInfoEdit(listqjtjbInfo);
	if(re<listqjtjbInfo.size()){
		result.put("result", 1); 
		result.put("error", "修改失败！"); 
	} 
	return result;
}

/**   
 * @Title: qjtjbEdit   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param qjtjb
 * @param @return    设定文件   
 *    返回类型   
 * @author ADC_ZH 
 * @param file2 
 * @param file1 
 * @date 上午9:27:12 
*/   
@Transactional
public Map<String, Object> qjtjbEdit(MultipartFile file1, MultipartFile file2, QJTJB qjtjb,String address) {
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	if(file1!=null){
//		List<QJTJB_INFO> qjtjbinfo1=importFile(file1,qjtjb,address); 
 		try {
			List<QJTJB_INFO> qjtjbinfo1 = ExcelBunk(file1,2,13,qjtjb );
			qjtjbDao.delQjtjbInfo(qjtjb.getID(),"N");
			qjtjbDao.insertQjtjbInfo(qjtjbinfo1,"N");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	} 
	if(file2!=null){
		try {
			List<QJTJB_INFO> qjtjbinfo2=ExcelBunk(file2,2,13,qjtjb );
			qjtjbDao.delQjtjbInfo(qjtjb.getID(),"Y");
			qjtjbDao.insertQjtjbInfo(qjtjbinfo2,"Y");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
	}
	int re =qjtjbDao.qjtjbEdit(qjtjb);
	if(re<1){
		result.put("result", 1); 
		result.put("error", "修改失败！"); 
	} 
	return result;
}

/**   
 * @Title: backData   
 * @Description: TODO(这里用一句话描述这个方法的作用)    
 * @param @param listTjb
 * @param @param qyid
 * @param @return    设定文件   
 *    返回类型   
 * @author ADC_ZH 
 * @date 上午10:44:16 
*/   
@Transactional
public Map<String, Object> backData(String[] ids, String qyid) {
	String reid="";
	Map<String, Object> result = new HashMap<>();
	result.put("result", 0); 
	for(String gg : ids){
		int re =qjtjbDao.backData(gg,qyid);
		if(re==0){
			result.put("result", 1); 
			result.put("error", "退回失败！"); 
		}
	}
	return result;
}
}
