package com.adc.da.bs.customized.enums;

import com.adc.da.bs.report.enums.FileTypeEnum;

/**
 * 定制服务
 *
 * @author 韩磊
 * @version V1.0
 * @date 2019-03-21 10:28
 **/
public enum CustomizedServiceEnum {

    /**
     *  数据定制
     */
    DATA(1,"数据定制"),
    /**
     *  报告定制
     */
    REPORT(2,"报告定制"),
    /**
     *  接口定制
     */
    API(3,"接口定制"),
    /**
     *  其他定制
     */
    ETC(4,"其他定制");

    private int value;

    private String name;

    CustomizedServiceEnum(int value, String name) {
        this.value = value;
        this.name = name;
    }

    public int getValue() {
        return value;
    }

    public String getName() {
        return name;
    }

    public static CustomizedServiceEnum getServiceEnumByValue(int value){
        for(CustomizedServiceEnum customizedService : CustomizedServiceEnum.values()){
            if(value == customizedService.getValue()){
                return customizedService;
            }
        }
        return null;
    }

    public static String getServiceEnumNameByValue(int value){
        for(CustomizedServiceEnum customizedService : CustomizedServiceEnum.values()){
            if(value == customizedService.getValue()){
                return customizedService.getName();
            }
        }
        return null;
    }
}
