package com.adc.da.bs.cvt.validate.entity;


import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ValidateVO {
    // 产品id
    private String cpId;
    // 产品型号
    private String cpxh;
    // 产品名称
    private String cpmc;
    // 产品长度 取多个值的最小值
    private String length;
    // 总质量(kg) 取多个值的最大值
    private String weight;
    // 额定载客(含驾驶员) 取多个值的最大值
    private String seats;
    // R点距地面垂直距离 取多个值的最大值
    private String heightForRPoint;
    // 检验项目
    private List<JYFA> jyfaList;
    // 区分推荐目录还是购置税车船税,1:推荐目录,2:购置税车船税
    private Integer chooseType;
    // 储能装置种类
    private String cnzz;
    // 动力电池能量密度（PED）0:未填写,1:已填写
    private String ped;
    // 动力电池（含超级电容器）最大充电倍率（CR）0:未填写,1:已填写
    private String cr;
    // 车辆分类
    private String cpType;
    // 车辆能源类型 1:纯电动 2:混合动力 3:燃料电池
    private Integer nylx;
    // 是否外资 0:国产     1:外资
    private Integer ifImport;

    public String getCpId() {
        return cpId;
    }

    public void setCpId(String cpId) {
        this.cpId = cpId;
    }

    public String getCpxh() {
        return cpxh;
    }

    public void setCpxh(String cpxh) {
        this.cpxh = cpxh;
    }

    public String getCpmc() {
        return cpmc;
    }

    public void setCpmc(String cpmc) {
        this.cpmc = cpmc;
    }

    public Integer getLength() {
        if ("".equals(length)){
            return -1;
        }
        String[] split = length.replaceAll(" ", "").split(",");
        List<Integer> lengthList = new ArrayList<>();
        for (String len : split) {
            int parseInt = Integer.parseInt(len);
            lengthList.add(parseInt);
        }
        Integer min = Collections.min(lengthList);
        return min;
    }

    public void setLength(String length) {
        this.length = length;
    }

    public Integer getWeight() {
        if ("".equals(weight)){
            return -1;
        }
        String[] split = weight.replaceAll(" ", "").split(",");
        List<Integer> weightList = new ArrayList<>();
        Integer parseInt;
        for (String s : split) {
            parseInt = Integer.parseInt(s);
            weightList.add(parseInt);
        }
        return Collections.max(weightList);
    }

    public void setWeight(String weight) {
        this.weight = weight;
    }

    public Integer getSeats() {
        if ("".equals(seats)){
            return -1;
        }
        String[] split = seats.replaceAll(" ", "").split(",");
        List<Integer> seatList = new ArrayList<>();
        int parseInt;
        for (String seat : split) {
            if (seat.contains("/")){
                seat = seat.substring(seat.indexOf("/") + 1, seat.length());
            }
            if (seat.contains("-")){
                seat = seat.substring(seat.indexOf("-") + 1, seat.length());
            }
            parseInt = Integer.parseInt(seat);
            seatList.add(parseInt);
        }
        return Collections.max(seatList);
    }

    public void setSeats(String seats) {
        this.seats = seats;
    }

    public Integer getHeightForRPoint() {
        if ("".equals(heightForRPoint)){
            return -1;
        }
        String[] split = heightForRPoint.replaceAll(" ", "").split(",");
        List<Integer> rList = new ArrayList<>();
        Integer parseInt = 0;
        for (String r : split) {
            if (r.contains("(")){
                // 1648(10.00-20轮胎),1651(10.00R20轮胎)
                parseInt = Integer.parseInt(r.substring(0, r.indexOf("(")));
            }else if (r.contains("+")){
                // 737+1100
                String[] split1 = r.replaceAll(" ", "").split("\\+");
                for (String s : split1) {
                    parseInt += Integer.parseInt(s);
                }
            }else {
                parseInt = Integer.parseInt(r);
            }
            rList.add(parseInt);
        }
        return Collections.max(rList);
    }

    public void setHeightForRPoint(String heightForRPoint) {
        this.heightForRPoint = heightForRPoint;
    }

    public List<JYFA> getJyfaList() {
        return jyfaList;
    }

    public void setJyfaList(List<JYFA> jyfaList) {
        this.jyfaList = jyfaList;
    }

    public Integer getChooseType() {
        return chooseType;
    }

    public void setChooseType(Integer chooseType) {
        this.chooseType = chooseType;
    }

    public String getCnzz() {
        return cnzz;
    }

    public void setCnzz(String cnzz) {
        this.cnzz = cnzz;
    }

    public String getPed() {
        if ("-".equals(ped) || "不适用".equals(ped) || ped == null || "".equals(ped)){
            return ped = "0";
        }else {
            return ped = "1";
        }
    }

    public void setPed(String ped) {
        this.ped = ped;
    }

    public String getCr() {
        if ("N/A".equals(cr) || cr == null || "N\\A".equals(cr) || "NA".equals(cr) || "否".equals(cr) && "/".equals(cr)
                || "--".equals(cr) || "-".equals(cr) || "".equals(cr)){
            return cr = "0";
        }else {
            return cr = "1";
        }
    }

    public void setCr(String cr) {
        this.cr = cr;
    }

    public String getCpType() {
        return cpType;
    }

    public void setCpType(String cpType) {
        this.cpType = cpType;
    }

    public Integer getNylx() {
        if ("".equals(cpmc)){
            return -1;
        }
        if (cpmc.contains("纯电动") || cpmc.contains("超级电容")){
            nylx = 1;
        }else if (cpmc.contains("插电式混合动力") || cpmc.contains("增程式混合动力")){
            nylx = 2;
        }else if (cpmc.contains("燃料电池")){
            nylx = 3;
        }
        return nylx;
    }

    public void setNylx(Integer nylx) {
        this.nylx = nylx;
    }

    public Integer getIfImport() {
        return ifImport;
    }

    public void setIfImport(Integer ifImport) {
        this.ifImport = ifImport;
    }
}
