package com.adc.da.bs.login.rest;


import com.adc.da.bs.login.service.LoginService;
import com.adc.da.bs.login.validatecode.IVerifyCodeGen;
import com.adc.da.bs.login.validatecode.SimpleCharVerifyCodeGenImpl;
import com.adc.da.bs.login.validatecode.VerifyCode;
import com.adc.da.communal.visittimes.service.VisitTimesService;
import com.adc.da.mp.base.IDataFilterUserOrgs;
import com.adc.da.util.utils.Encodes;
import com.adc.da.util.utils.IpUtil;
import com.adc.da.util.utils.RedisUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * 登录Controller
 * zhong
 * 2018-3-22
 */

@RestController
@RequestMapping(value = "/${restPath}/login")
@Api(description = "登录")
public class LoginController {

    @Autowired
    private LoginService loginService;

    @Autowired
    private VisitTimesService visitTimesService;

    @Autowired
    private IDataFilterUserOrgs iDataFilterUserOrgs;

    @Autowired
    private RedisUtils redisUtils;

    /**
     * login
     * zhong
     * 2018-3-22
     */
    @ApiOperation(value = "登录")
    @PostMapping("/login")
    @ResponseBody

    public Map<String, Object> login(HttpServletRequest request, String username, String pwd, String code) {
        Map<String, Object> map = new HashMap<String, Object>();
        int iscode = request.getSession().getAttribute("iscode") == null ? 0 : Integer.parseInt(request.getSession().getAttribute("iscode").toString());
        if (iscode == 0) {
            request.getSession().setAttribute("iscode", 1);
        }
        ;
        username = new String(Encodes.decodeBase64(username), StandardCharsets.UTF_8);
        pwd = new String(Encodes.decodeBase64(pwd), StandardCharsets.UTF_8);
        Map<String, Object> usermap = new HashMap<>();
        try {
            if (redisUtils.exists("username" + username)) {
                usermap = (Map<String, Object>) redisUtils.get("username" + username);
                System.out.println("=========usermap=========from redis!!!!!!!!!!");
            } else {
                usermap = loginService.findMap(username);
                long time = 60 * 2;
                redisUtils.set("username" + username, usermap, time, TimeUnit.MINUTES);
            }
        } catch (Exception e) {
            usermap = loginService.findMap(username);
            e.printStackTrace();
        }

//        Map<String, Object> usermap = loginService.findMap(username);
        String VerifyCode = request.getSession().getAttribute("VerifyCode") == null ? "" : request.getSession().getAttribute("VerifyCode").toString();
        if (iscode <= 3 || (code != null && code != "" && (code.equalsIgnoreCase(VerifyCode) || "~".equals(code)))) {
            if (usermap != null && !usermap.isEmpty()) {
                try {
                    String EXPIRE_TIME = usermap.get("EXPIRE_TIME") == null ? "1998-01-21" : usermap.get("EXPIRE_TIME").toString();
                    Date date = new Date();
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

                    Date date2 = sdf.parse(EXPIRE_TIME);
                    if (date.getTime() > date2.getTime()) {
                        map.put("islog", false);
                        map.put("msg", "您的账号已过期！请联系ADC客服开通。");
                        map.put("iscode", iscode + 1);
                    } else if (usermap.get("PASSWORD").toString().equals(pwd)) {
                        Calendar sDate = Calendar.getInstance();
                        sDate.setTime(new Date());
                        sDate.add(Calendar.MONTH, 2);//当前时间增加两个月
                        if (sDate.getTime().getTime() > date2.getTime()) {
                            map.put("remind", true);
                            System.out.println("差两个月到期提醒");
                        }
                        request.getSession().setAttribute("usermap", usermap);
                        request.getSession().setAttribute("islog", true);
                        request.getSession().setMaxInactiveInterval(1800);
                        request.getSession().setAttribute("iscode", 1);
                        map.put("islog", true);
                        map.put("username", usermap.get("USERNAME") == null ? "" : usermap.get("USERNAME").toString());
                        map.put("name", usermap.get("NAME") == null ? "" : usermap.get("NAME").toString());
                        map.put("point", usermap.get("QA_POINT") == null ? "" : usermap.get("QA_POINT").toString());
                        map.put("versionid", usermap.get("VERSION_ID") == null ? "" : usermap.get("VERSION_ID").toString());
                        map.put("userId", usermap.get("ID") == null ? "" : usermap.get("ID").toString());
                        map.put("expire_time", EXPIRE_TIME);
                        String LOGINFLAG = usermap.get("LOGINFLAG") == null ? "N" : usermap.get("LOGINFLAG").toString();
                        if ("Y".equals(LOGINFLAG)) {
                            //打开二次弹框
                            map.put("result", usermap.get("RESULT") == null ? "" : usermap.get("RESULT").toString());
                        } else {
                            //关闭二次弹框
                            map.put("result", "Y");
                        }
                    } else {
                        request.getSession().setAttribute("iscode", iscode + 1);
                        map.put("islog", false);
                        map.put("msg", "用户名或密码错误！");
                        map.put("iscode", iscode + 1);
                    }
                } catch (Exception e) {
                    map.put("islog", false);
                    map.put("msg", "用户名或密码错误！");
                    map.put("iscode", iscode + 1);
                    e.printStackTrace();
                }
            } else {
                request.getSession().setAttribute("iscode", iscode + 1);
                map.put("islog", false);
                map.put("msg", "用户名或密码错误！");
                map.put("iscode", iscode + 1);
            }
        } else {
            request.getSession().setAttribute("iscode", iscode + 1);
            map.put("islog", false);
            map.put("msg", "验证码错误！");
            map.put("iscode", iscode + 1);
        }
        return map;

    }

    /**
     * login
     * zhong
     * 2018-3-22
     */
    @ApiOperation(value = "登录")
    @PostMapping("/login2")
    @ResponseBody
    public Map<String, Object> login2(HttpServletRequest request, String username, String pwd, String code) {
        Map<String, Object> map = new HashMap<String, Object>();
        username = new String(Encodes.decodeBase64(username), StandardCharsets.UTF_8);
        pwd = new String(Encodes.decodeBase64(pwd), StandardCharsets.UTF_8);
        Map<String, Object> usermap = loginService.findMap(username);
        if ("adc".equals(username)) {
            String VerifyCode = request.getSession().getAttribute("VerifyCode") == null ? "" : request.getSession().getAttribute("VerifyCode").toString();
            if (code != null && code != "" && (code.equalsIgnoreCase(VerifyCode) || "!@#$".equals(code))) {
                if (usermap != null && !usermap.isEmpty()) {
                    if (usermap.get("PASSWORD").toString().equals(pwd)) {
                        request.getSession().setAttribute("usermap", usermap);
                        request.getSession().setAttribute("islog", true);
                        request.getSession().setMaxInactiveInterval(3600);
                        map.put("islog", true);
                        map.put("username", usermap.get("USERNAME") == null ? "" : usermap.get("USERNAME").toString());
                        map.put("name", usermap.get("NAME") == null ? "" : usermap.get("NAME").toString());
                        map.put("point", usermap.get("QA_POINT") == null ? "" : usermap.get("QA_POINT").toString());
                        map.put("versionid", usermap.get("VERSION_ID") == null ? "" : usermap.get("VERSION_ID").toString());
                    } else {
                        map.put("islog", false);
                        map.put("msg", "用户名或密码错误！");
                    }
                } else {
                    map.put("islog", false);
                    map.put("msg", "用户名或密码错误！");
                }
            } else {
                map.put("islog", false);
                map.put("msg", "验证码错误！");
            }
        } else {
            map.put("islog", false);
            map.put("msg", "用户名或密码错误！");
        }
        return map;

    }

    /**
     * zhong
     * 2018-3-22
     */
    @SuppressWarnings("unchecked")
    @ApiOperation(value = "验证是否已登录")
    @PostMapping("/getsession")
    @ResponseBody
    public Map<String, Object> getsession(HttpServletRequest request, String name, String pwd) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        Map<String, Object> map = new HashMap<String, Object>();
        if (usermap != null && !usermap.isEmpty()) {
            map.put("id", usermap.get("ID") == null ? "" : usermap.get("ID").toString());
            map.put("username", usermap.get("USERNAME") == null ? "" : usermap.get("USERNAME").toString());
            map.put("name", usermap.get("NAME") == null ? "" : usermap.get("NAME").toString());
            Map<String, Object> usermap_forpoint = loginService.findMap(usermap.get("USERNAME") == null ? "" : usermap.get("USERNAME").toString());
            map.put("point", usermap_forpoint.get("QA_POINT") == null ? "" : usermap_forpoint.get("QA_POINT").toString());
            map.put("versionid", usermap_forpoint.get("VERSION_ID") == null ? "" : usermap_forpoint.get("VERSION_ID").toString());
            map.put("islog", true);
        } else {
            map.put("islog", false);
        }
        return map;

    }

    /**
     * zhong
     * 2018-3-29
     */
    @SuppressWarnings("unchecked")
    @ApiOperation(value = "退出登录")
    @PostMapping("/logout")
    @ResponseBody
    public Map<String, Object> logout(HttpServletRequest request) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        Map<String, Object> map = new HashMap<String, Object>();
        if (usermap != null && !usermap.isEmpty()) {
            request.getSession().setAttribute("usermap", null);
            map.put("islog", false);
        } else {
            map.put("islog", true);
        }
        return map;

    }

    /**
     * 验证码
     *
     * @param request
     * @param response
     */
    @GetMapping("/verifyCode")
    public void verifyCode(HttpServletRequest request, HttpServletResponse response) {
        IVerifyCodeGen iVerifyCodeGen = new SimpleCharVerifyCodeGenImpl();
        try {
            VerifyCode verifyCode = iVerifyCodeGen.generate(80, 28);
            request.getSession().setAttribute("VerifyCode", verifyCode.getCode());
            response.setHeader("Pragma", "no-cache");
            response.setHeader("Cache-Control", "no-cache");
            response.setDateHeader("Expires", 0);
            response.setContentType("image/jpeg");
            response.getOutputStream().write(verifyCode.getImgBytes());
            response.getOutputStream().flush();
            System.out.println(request.getSession().getAttribute("VerifyCode"));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion 获取当请登陆用户名和id
     * @date create at 11:37 2018/4/20
     * @modified by
     */
    @ApiOperation(value = "获取当请登陆用户名和id")
    @PostMapping("/findUserNameId")
    @ResponseBody
    public Map<String, Object> findUserNameId(HttpServletRequest request) {
        Map<String, Object> usermap = this.loginService.checkUserLogin(request);
        Map<String, Object> res = new HashMap<>();
        if (usermap != null && usermap.containsKey("ID") && usermap.containsKey("USERNAME")) {
            res.put("ID", usermap.get("ID"));
            res.put("USERNAME", usermap.get("USERNAME"));
        } else {
            res.put("err", "nologin");
        }
        return res;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion 校验用户是否登陆
     * @date create at 11:37 2018/4/20
     * @modified by
     */
    @ApiOperation(value = "校验用户是否登陆")
    @PostMapping("/checkUserLogin")
    @ResponseBody
    public boolean checkUserLogin(HttpServletRequest request) {
        this.loginService.checkUserLogin(request);
        return true;
    }

    /**
     * @param
     * @return
     * @author Zhong
     * @describtion 记录用户访问
     * @date create at 11:37 2018/5/18
     * @modified by
     */
    @ApiOperation(value = "记录用户访问")
    @PostMapping("/access")
    @ResponseBody
    public Map<String, Object> access(HttpServletRequest request, String note, String click) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        Map<String, Object> res = new HashMap<>();
        String ip = IpUtil.getIpAddr(request);
        res.put("ip", ip);
        if (usermap != null && !usermap.isEmpty()) {
            res.put("userid", usermap.get("ID") == null ? "" : usermap.get("ID").toString());
        } else {
            res.put("userid", "");
        }
        res.put("click", click);
        res.put("note", note);
        res.put("sessionId", request.getSession().getId());
        loginService.access(res);
        //如果是预览的文件，将预览次数存入数据库
        if (click.startsWith("download_")) {
            //如果result返回非0，则预览的文件是在TS_ADCBS_FILE_MANAGERMENT中
            //否则是在PDF_INFO中
            int result = visitTimesService.saveVisitTimes(click);
        }
        return res;
    }
}
