package com.adc.da.bs.manage.rest;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.adc.da.bs.manage.entity.PolicyManageEntity;
import com.adc.da.bs.manage.service.PolicyManageService;
import com.adc.da.util.http.PageParam;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
/**
 * 4.4.2.	政策解读管理
 * @author LuZhiPeng
 *
 */

@Controller
@RequestMapping(value = "/${restPath}/policymanage")
@Api(description = "政策解读管理")
public class PolicyManageController {
	@Autowired
	private PolicyManageService policyManageService;
	
	@ApiOperation(value = "列表政策解读管理")
    @PostMapping("/indexList")
    @ResponseBody
    public Map<String, Object> indexlist(HttpServletRequest request,PageParam page) {
		page.setLimit(15);
		page.setOffset(0);
		Map<String,Object> pageMap =policyManageService.findWorkIndex(page);//首页取15条数据
        return pageMap;
    	
    }
	
	@ApiOperation(value = "条件查询政策解读管理")
    @PostMapping("/policymanageList")
    @ResponseBody
    public Map<String, Object> findWorkList(HttpServletRequest request,PageParam page, String source, String title) {
		
    	Map<String,Object> pageMap =policyManageService.findWorkList(page, source, title);
        return pageMap; 
    }
	
	@ApiOperation(value = "政策解读管理文件增加浏览量")
    @PostMapping("/viewCount")
    @ResponseBody
    public void viewCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = policyManageService.changeViewCount(id);//首页取15条数据
      
    }	
	
	@ApiOperation(value = "政策解读管理文件增加下载量")
    @PostMapping("/downloadCount")
    @ResponseBody
    public void downloadCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = policyManageService.changeDownloadCount(id);//首页每种取5条
      
    }	
	
	@ApiOperation(value = "删除政策解读管理文件")
    @PostMapping("/delete")
    @ResponseBody
    public void deleteWork(HttpServletRequest request ,Integer id) {
		
    	boolean i = policyManageService.deleteWork(id);//首页每种取5条
      
    }	
	
	 @PostMapping("/addPolicymanage")
	 @ResponseBody
	 @ApiOperation(value = "添加政策解读管理文件")
	    public Map<String, Object> addWork(HttpServletRequest request, @RequestBody PolicyManageEntity policyManageEntity){	      
	        Map<String, Object> res = policyManageService.addWork(policyManageEntity);
	        return res;
	    }
}
