package com.adc.da.bs.manage.rest;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.adc.da.bs.manage.entity.StandardManageEntity;
import com.adc.da.bs.manage.service.StandardManageService;
import com.adc.da.util.http.PageParam;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 *4.4.1.	标准预告管理
 * @author LuZhiPeng
 *
 */
@Controller
@RequestMapping(value = "/${restPath}/standardmanage")
@Api(description = "标准预告管理")
public class StandardManageController {
	@Autowired
	private StandardManageService standardManageService;
	@ApiOperation(value = "即将生效标准管理列表")
    @PostMapping("/indexList")
    @ResponseBody
    public Map<String, Object> indexList(HttpServletRequest request,PageParam page) {
		if (page.getLimit()==null){			
			page.setLimit(15);
			page.setOffset(0);
		}
		Map<String,Object> pageMap =standardManageService.findWorkIndex(page);//首页每种取15条
        return pageMap;
    	
    } 
	@ApiOperation(value = "征求意见管理列表")
    @PostMapping("/adviseList")
    @ResponseBody
    public Map<String, Object> adviseList(HttpServletRequest request,PageParam page, String type, String keyName) {
		if (page.getLimit()==null){			
			page.setLimit(15);
			page.setOffset(0);
		}
		Map<String,Object> pageMap =standardManageService.adviseList(page, type, keyName);//首页每种取15条
        return pageMap;
    	
    }
	
	@ApiOperation(value = "查询即将生效标准管理列表")
    @PostMapping("/standardmanageList")
    @ResponseBody
    public Map<String, Object> findWorkList(HttpServletRequest request,PageParam page, String type, String keyName) {
		
    	Map<String,Object> pageMap =standardManageService.findWorkList(page, type, keyName);
        return pageMap; 
    }
	
	@ApiOperation(value = "发布历史管理列表")
    @PostMapping("/indexListHistory")
    @ResponseBody
    public Map<String, Object> indexListHistory(HttpServletRequest request,PageParam page) {
		if (page.getLimit()==null){			
			page.setLimit(15);
			page.setOffset(0);
		}
		Map<String,Object> pageMap =standardManageService.findWorkIndexHistory(page);//首页取15条数据
        return pageMap;
    	
    }
	
	@ApiOperation(value = "查询发布历史管理列表")
    @PostMapping("/standardmanageListHistory")
    @ResponseBody
    public Map<String, Object> findWorkListHistory(HttpServletRequest request,PageParam page, String type, String keyName) {
		
    	Map<String,Object> pageMap =standardManageService.findWorkListHistory(page, type, keyName);
        return pageMap; 
    }
	
	@ApiOperation(value = "首页标准预告2021")
    @PostMapping("/findWorkListIndex")
    @ResponseBody
    public Map<String, Object> findWorkListIndex(HttpServletRequest request,PageParam page, String type, String keyName) {
		page.setLimit(2);
		page.setOffset(0);
    	Map<String,Object> pageMap =standardManageService.findWorkListIndex(page, type, keyName);
        return pageMap; 
    }
	@ApiOperation(value = "标准预告管理文件增加浏览量")
    @PostMapping("/viewCount")
    @ResponseBody
    public void viewCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = standardManageService.changeViewCount(id);//首页取15条数据
      
    }	
	
	@ApiOperation(value = "标准预告管理文件增加下载量")
    @PostMapping("/downloadCount")
    @ResponseBody
    public boolean downloadCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = standardManageService.changeDownloadCount(id);
    	return i;
    }	
	
	@ApiOperation(value = "标准预告管理文件删除")
    @PostMapping("/delete")
    @ResponseBody
    public boolean deleteWork(HttpServletRequest request ,Integer id) {
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
		if (!"61077".equals(usermap.get("ID").toString()) || !"adc".equals(usermap.get("USERNAME").toString())) {
			return false;
        }else{        	
        	boolean i = standardManageService.deleteWork(id);
        	return i;
        }
    }	
	
	 @PostMapping("/addStandardmanage")
	 @ResponseBody
	 @ApiOperation(value = "添加标准预告管理文件")
	    public Map<String, Object> addWork(HttpServletRequest request, @RequestBody StandardManageEntity standardManageEntity){	      
	        Map<String, Object> res = standardManageService.addWork(standardManageEntity);
	        return res;
	    }
	 
	 @PostMapping("/getDate")
	 @ResponseBody
	 @ApiOperation(value = "获取最新时间")
	    public Map<String, Object> getDate (HttpServletRequest request){	      
	        Map<String, Object> res = standardManageService.getDate();
	        return res;
	    }
}
