package com.adc.da.bs.manage.rest;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.adc.da.bs.manage.entity.WorkManageEntity;
import com.adc.da.bs.manage.service.WorkManageService;
import com.adc.da.util.http.PageParam;

/**
 * 4.3.	办事指南管理
 * 
 */

@Controller
@RequestMapping(value = "/${restPath}/workmanage")
@Api(description = "办事指南管理")
public class WorkManageController {
	 private final Logger logger = LoggerFactory.getLogger(getClass());
	@Autowired
	private WorkManageService workManageService;
	
	@ApiOperation(value = "办事指南列表")
    @PostMapping("/indexList")
    @ResponseBody
    public Map<String, Object> indexlist(HttpServletRequest request,PageParam page) {
		page.setLimit(15);
		page.setOffset(0);
		Map<String,Object> pageMap =workManageService.findWorkIndex(page);//首页取15条数据
        return pageMap;
    	
    }
	
	@ApiOperation(value = "办事指南查询2021-8项")
    @PostMapping("/workmanageList")
    @ResponseBody
    public Map<String, Object> findWorkList(HttpServletRequest request,PageParam page, String type, String name) {
		
    	Map<String,Object> pageMap =workManageService.findWorkList(page, type, name);
        return pageMap; 
    }
	
	@ApiOperation(value = "办事指南文件增加浏览量")
    @PostMapping("/viewCount")
    @ResponseBody
    public void viewCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = workManageService.changeViewCount(id);
      
    }	
	
	@ApiOperation(value = "办事指南文件增加下载量")
    @PostMapping("/downloadCount")
    @ResponseBody
    public void downloadCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = workManageService.changeDownloadCount(id);
      
    }	
	
	@ApiOperation(value = "办事指南文件删除")
    @PostMapping("/delete")
    @ResponseBody
    public boolean deleteWork(HttpServletRequest request ,Integer id) {
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
		if (!"61077".equals(usermap.get("ID").toString()) || !"adc".equals(usermap.get("USERNAME").toString())) {
			return false;
        }else{         	
        	boolean i = workManageService.deleteWork(id);
        	return i;
        }
    }	
	
	 @PostMapping("/addWorkmanage")
	 @ResponseBody
	 @ApiOperation(value = "添加办事指南文件")
	 public Map<String, Object> addWork(HttpServletRequest request, @RequestBody WorkManageEntity workManageEntity){	      
		 Map<String, Object> res = workManageService.addWork(workManageEntity);
	     return res;
	 }

	 @PostMapping("/workmanageIndex")
	 @ResponseBody
	 @ApiOperation(value = "办事指南首页2021")
	 public Map<String, Object> workmanageIndex(HttpServletRequest request,PageParam page){
		 page.setLimit(2);
		 page.setOffset(0);
		 Map<String, Object> res = workManageService.workmanageIndex(page);
	     return res;
	 }
}
