package com.adc.da.bs.manage.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.adc.da.bs.manage.dao.RecordManageDao;
import com.adc.da.bs.manage.entity.RecordManageEntity;
import com.adc.da.util.http.PageParam;
/**
 *4.5.	备案经验管理 
 * @author LuZhiPeng
 *
 */

@Service
public class RecordManageService {
	@Autowired
	private RecordManageDao recordManageDao;
/**
 * 索引分页查询列表	
 * @param page
 * @return
 */
	public Map<String, Object> findWorkIndex(PageParam page){
		Map<String, Object> result = new HashMap<>();
		Long count = recordManageDao.findTotalCount(page, null, null);
		List<Map<String, Object>> list = recordManageDao.findAllByPage(page);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
/**
 * 按条件查询记录并分页
 * @param page
 * @param type
 * @param expName
 * @return
 */
	public Map<String, Object> findWorkList(PageParam page,String type, String expName) {
		Map<String, Object> result = new HashMap<>();
		Long count = recordManageDao.findTotalCount(page, type, expName);
		List<Map<String, Object>> list = recordManageDao.findListByPage(page, type, expName);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
	 /**
     * 增加新记录
     * @param recordManageEntity
     * @return
     */	
	@Transactional
	public Map<String,Object> addWork(RecordManageEntity recordManageEntity){
		Map<String, Object> result = recordManageDao.insertWork(recordManageEntity);
		return result;
	}
	@Transactional
	public boolean changeViewCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=recordManageDao.changeViewCountById(id);
		return i;
	}
	@Transactional
	public boolean changeDownloadCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=recordManageDao.changeDownloadCountById(id);
		return i;
	}
	@Transactional
	public boolean deleteWork(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=recordManageDao.deleteWork(id);
		return i;
	}
	
}
