package com.adc.da.bs.manage.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.adc.da.bs.manage.dao.StandardManageDao;
import com.adc.da.bs.manage.entity.StandardManageEntity;
import com.adc.da.util.http.PageParam;

@Service
public class StandardManageService {
	@Autowired
	private StandardManageDao standardManageDao;
	/**即将生效标准
	 * 索引分页查询列表	
	 * @param page
	 * @return
	 */
	public Map<String, Object> findWorkIndex(PageParam page){
		Map<String, Object> result = new HashMap<>();
		Long count = standardManageDao.findTotalCount(page, null, null);
		List<Map<String, Object>> list = standardManageDao.findAllByPage(page);
		result.put("total", count);
		result.put("rows", list);

		return result;
		}
		
	/**即将生效标准
	* 按条件查询记录并分页
	* @param page
	* @param type
	* @param keyName
	* @return
	*/
	public Map<String, Object> findWorkList(PageParam page,String type, String keyName) {
		Map<String, Object> result = new HashMap<>();
		Long count = standardManageDao.findTotalCount(page, type, keyName);
		List<Map<String, Object>> list = standardManageDao.findListByPage(page, type, keyName);
		result.put("total", count);
		result.put("rows", list);

		return result;
		}
	
	/**发布历史查询
	 * 索引分页查询列表	
	 * @param page
	 * @return
	 */
	public Map<String, Object> findWorkIndexHistory(PageParam page){
		Map<String, Object> result = new HashMap<>();
		Long count = standardManageDao.findTotalCountHistory(page, null, null);
		List<Map<String, Object>> list = standardManageDao.findAllByPageHistory(page);
		result.put("total", count);
		result.put("rows", list);

		return result;
		}
		
	/**发布历史查询
	* 按条件查询记录并分页
	* @param page
	* @param type
	* @param keyName
	* @return
	*/
	public Map<String, Object> findWorkListHistory(PageParam page,String type, String keyName) {
		Map<String, Object> result = new HashMap<>();
		Long count = standardManageDao.findTotalCountHistory(page, type, keyName);
		List<Map<String, Object>> list = standardManageDao.findListByPageHistory(page, type, keyName);
		result.put("total", count);
		result.put("rows", list);

		return result;
		}
	 /**
     * 增加新记录
     * @param standardManageEntity
     * @return
     */	
	@Transactional
	public Map<String,Object> addWork(StandardManageEntity standardManageEntity){
		Map<String, Object> result = standardManageDao.insertWork(standardManageEntity);
		return result;
	}
	@Transactional
	public boolean changeViewCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=standardManageDao.changeViewCountById(id);
		return i;
	}
	@Transactional
	public boolean changeDownloadCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=standardManageDao.changeDownloadCountById(id);
		return i;
	}
	@Transactional
	public boolean deleteWork(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=standardManageDao.deleteWork(id);
		return i;
	}

	/**   
	 * @Title: getDate   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午4:07:04 
	*/   
	public Map<String, Object> getDate() {
		Map<String, Object> result = new HashMap<>();
		result=standardManageDao.getDate();
		return result;
	}

	/**   
	 * @Title: findWorkListIndex   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param type
	 * @param @param keyName 
	 * @author ADC_ZH 
	 * @date 上午11:17:35 
	*/   
	public Map<String, Object> findWorkListIndex(PageParam page, String type,
			String keyName) {
		Map<String, Object> result = new HashMap<>();
		List<Map<String, Object>> qb = standardManageDao.findListByPage(page, "强标", keyName);
		Long qbcount = standardManageDao.findTotalCount(page, "强标", keyName);
		List<Map<String, Object>> tb= standardManageDao.findListByPage(page, "推标", keyName);
		Long tbcount = standardManageDao.findTotalCount(page, "推标", keyName);
		Map<String, Object> future = new HashMap<>();
		future.put("qb", qb);
		future.put("qbcount", qbcount);
		future.put("tb", tb);
		future.put("tbcount", tbcount);
		
		List<Map<String, Object>> qbhistory = standardManageDao.findListByPageHistory(page, "强标", keyName);
		Long qbcounthistory = standardManageDao.findTotalCountHistory(page, "强标", keyName);
		List<Map<String, Object>> tbhistory = standardManageDao.findListByPageHistory(page, "推标", keyName);
		Long tbcounthistory = standardManageDao.findTotalCountHistory(page, "推标", keyName);
		Map<String, Object> history = new HashMap<>();
		history.put("qb", qbhistory);
		history.put("qbcount", qbcounthistory);
		history.put("tb", tbhistory);
		history.put("tbcount", tbcounthistory);
		
		result.put("future", future);
		result.put("history", history);
		

		List<Map<String, Object>> adviseList = standardManageDao.adviseList(page, "征求意见", keyName);
		Long adviseCount = standardManageDao.adviseCount(page, "征求意见", keyName);
		Map<String, Object> advise = new HashMap<>();
		advise.put("adviseList", adviseList);
		advise.put("adviseCount", adviseCount);
		result.put("advise", advise);

		return result;
	}

	/**   
	 * @Title: adviseList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午7:14:57 
	*/   
	public Map<String, Object> adviseList(PageParam page, String type, String keyName) {
		List<Map<String, Object>> adviseList = standardManageDao.adviseList(page, "征求意见", keyName);
		Long adviseCount = standardManageDao.adviseCount(page, "征求意见", keyName);
		Map<String, Object> advise = new HashMap<>();
		advise.put("rows", adviseList);
		advise.put("total", adviseCount); 

		return advise; 
	}

}
