package com.adc.da.bs.manage.service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.adc.da.bs.manage.dao.WorkManageDao;
import com.adc.da.bs.manage.entity.WorkManageEntity;
import com.adc.da.bs.policy.dao.PolicyDao;
import com.adc.da.util.http.PageParam;

/**
 * 4.3. 办事指南管理
 * 
 * @author LuZhiPeng
 *
 */
@Service
public class WorkManageService {
	@Autowired
	private WorkManageDao workManageDao;

    @Autowired
    private PolicyDao policyDao;
	
	public Map<String, Object> findWorkIndex(PageParam page){
		Map<String, Object> result = new HashMap<>();
		Long count = workManageDao.findTotalCount(page, null, null);
		List<Map<String, Object>> list = workManageDao.findAllByPage(page);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
/**
 * 按条件查询记录并分页
 * @param page
 * @param sDate
 * @param eDate
 * @param type
 * @param name
 * @return
 */
	public Map<String, Object> findWorkList(PageParam page,String type, String name) {
		Map<String, Object> result = new HashMap<>();
		Long count = workManageDao.findTotalCount(page, type, name);
		List<Map<String, Object>> list = workManageDao.findListByPage(page, type, name);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
	 /**
     * 增加新记录
     * @param workManageEntity
     * @return
     */	
	@Transactional
	public Map<String,Object> addWork(WorkManageEntity workManageEntity){
		Map<String, Object> result = workManageDao.insertWork(workManageEntity);
		return result;
	}
	@Transactional
	public boolean changeViewCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=workManageDao.changeViewCountById(id);
		return i;
	}
	@Transactional
	public boolean changeDownloadCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=workManageDao.changeDownloadCountById(id);
		return i;
	}
	@Transactional
	public boolean deleteWork(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=workManageDao.deleteWork(id);
		return i;
	}
	/**   
	 * @Title: workmanageIndex   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 上午10:21:56 
	*/   
	public Map<String, Object> workmanageIndex(PageParam page) {
		List<Map<String, Object>> list=workManageDao.workmanageIndex();
		List<Map<String, Object>> countList=workManageDao.workmanageIndexCountList(); 
		Long zcjdcount = policyDao.findTotalCount(null, null, null,"3");//政策解读
		List<Map<String, Object>> zcjd=policyDao.findListByPage(page, null, null,"3");//政策解读
		Map<String, Object> remap = new HashMap<>(); 
		remap.put("bszn", list);
		remap.put("bszncount", countList);
		remap.put("zcjd", zcjd);
		remap.put("zcjdcount", zcjdcount);

		return remap;
	}
	
	
	

}
