package com.adc.da.bs.other.dao;

import com.adc.da.util.http.PageParam;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.util.Map;
/*import com.adc.da.enterprise.entity.EncodeRuleBasicEO;
import com.adc.da.enterprise.entity.EnterpriseAppEO;
import com.adc.da.enterprise.entity.EnterpriseEO;*/

/**
 * 推荐目录Dao
 * zhong
 * 2018-3-22
 */


@Component
public class NewsDao {
    protected final EntityManager entityManager;

    @Autowired
    public NewsDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }

    @SuppressWarnings("unchecked")
    public List<Map<String, Object>> indexlist(PageParam page, int typeid, String name) {
        StringBuffer bf = new StringBuffer();
        bf.append("select rm,id,REPLACE(title , '^',' ') title,CLICKCOUNT,type,url, ");
        bf.append(" to_char(rel_time,'MM-DD') as rel_time1,");
        bf.append(" to_char(sysdate,'yyyy-MM-DD') as today,");
        bf.append(" to_char(rel_time,'yyyy-MM-DD') as rel_time ");
        bf.append(" from (");
        /*bf.append(" select id,title,type,url,rel_time from retrieval.industry_news where 1=2 union");*/
        bf.append(" select rm, id,title,CLICKCOUNT,type,url,rel_time from ");
        bf.append(" (select a.id,a.title,a.CLICKCOUNT,a.type,a.url,a.rel_time,rownum rm from ");
        bf.append(" (select id, title,CLICKCOUNT, type,url,rel_time,rownum rm from ");
        bf.append(" retrieval.industry_news where 1=1 ");
        //行业资讯类型去掉2018-5-4
        if (typeid != 0) {
            bf.append(" and type = ? ");
        }
        if (name != null && !"".equals(name)) {
            bf.append(" and title like '%" + name + "%'");
        }
        /*if(typeid==8) bf.append(" or type in ('7','6','5') ");*/
        bf.append(" order by rel_time desc) a ) b  ");
        bf.append(") order by rel_time desc");
        Query query = entityManager.createNativeQuery(bf.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if (typeid != 0) {
            query.setParameter(1, typeid);
        }
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }

    public Long findPageCount(int type, String name) {
        StringBuilder queryBuilder = new StringBuilder(" SELECT count(*) FROM ( ");
        queryBuilder.append("select id,title,type,url,rel_time from retrieval.industry_news where 1=2");
        queryBuilder.append(" union select id,title,type,url,rel_time from ");
        queryBuilder.append(" (select a.id,a.title,a.type,a.url,a.rel_time,rownum rm from ");
        queryBuilder.append(" (select id, title, type,url,rel_time,rownum rm from ");
        queryBuilder.append(" retrieval.industry_news where 1=1 ");
        //行业资讯类型去掉2018-5-4
        if (type != 0) {
            queryBuilder.append(" and type = ? ");
        }
        if (name != null && !"".equals(name)) {
            queryBuilder.append(" and title like '%" + name + "%'");
        }
        /*if(type==8) queryBuilder.append(" or type in ('7','6','5') ");*/
        queryBuilder.append(" order by rel_time desc) a ) b  ");
        queryBuilder.append(") ");
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
        if (type != 0) {
            query.setParameter(1, type);
        }
        Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
    }

    /**
     * 行业资讯点击数量增加
     * zhong
     * 2018-5-29
     */

    @Transactional
    public int clickcount(String iD) {
        Integer cqidi = Integer.parseInt(iD);
        String updatePointSql = " UPDATE RETRIEVAL.INDUSTRY_NEWS SET CLICKCOUNT = (CLICKCOUNT+1) WHERE ID = ? ";
        Query updateQuery = entityManager.createNativeQuery(updatePointSql);
        updateQuery.setParameter(1, iD);
        int i = updateQuery.executeUpdate();
        return i;
    }

    /**
     * @param @param  types
     * @param @return 设定文件
     * @return "List<Map<String,Object>>" 返回类型
     * @Title: newsIndexList
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午6:35:49
     */
    public List<Map<String, Object>> newsIndexList(String types) {
        StringBuffer bf = new StringBuffer();
        bf.append(" SELECT  *  FROM ");
        bf.append("	(SELECT  i.URL,REPLACE(i.TITLE, '^', '') TITLE,  I.ID,  i.TYPE,  row_number() over (partition by TYPE order by id desc) rn,"
                + " ( CASE WHEN SYSDATE-3<i.CREATE_TIME THEN '1' ELSE '0' END ) ISNEW    FROM 	retrieval.industry_news  i ");
        bf.append(" WHERE TYPE in ('1','2','3','6' ) ) ");
        bf.append("	WHERE  rn<4 ORDER BY TYPE  ");
        Query query = entityManager.createNativeQuery(bf.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//		query.setParameter(1,types); 
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }

    /**
     * @param @param  types
     * @param @return 设定文件
     * @Title: newsIndexCountList
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午6:35:54
     */
    public List<Map<String, Object>> newsIndexCountList(String types) {
        StringBuffer bf = new StringBuffer();
        bf.append("	SELECT TYPE,COUNT(*),SUM (CLICKCOUNT) FROM 	retrieval.industry_news ");
        bf.append("	WHERE TYPE in ('1','2','3','6' )");
        bf.append("	GROUP BY TYPE  ");
        Query query = entityManager.createNativeQuery(bf.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//		query.setParameter(1,types); 
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }


}
