package com.adc.da.bs.other.rest;

import com.adc.da.bs.other.service.NewsService;
import com.adc.da.bs.webservice.util.DESUtil;
import com.adc.da.util.utils.Encodes;
import com.adc.da.util.utils.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.apache.cxf.endpoint.Client;
import org.apache.cxf.jaxws.endpoint.dynamic.JaxWsDynamicClientFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;

/**
 * 跳转Controller
 * zhong
 * 2020-12-28
 */

@RestController
@RequestMapping(value = "/${restPath}/skip")
@Api(description = "跳转")
public class SkipController {
    @Value("${skipPath}")
    private String skipPath;
    
	@Autowired
	private NewsService newsService;
	
	/**
	 * 形势认证
	 * zhong
	 * 2020-12-28
	 */
	@ApiOperation(value = "形式认证")
    @PostMapping("/xxrzSkip")
    @ResponseBody
    public Map<String, Object> xxrzSkip(HttpServletRequest request) { 
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
    	Map<String, Object> map=new HashMap<String, Object>();
    	JaxWsDynamicClientFactory clientFactory = JaxWsDynamicClientFactory.newInstance();  
    	Client client = clientFactory.createClient("http://39.100.75.112:45053/services/TokenADCSerivce?wsdl");  
		try {
		     Object[] result = client.invoke("createADCToken", new Object[]{qyid,qyid,"VTAMSENTADC001"});  
		     System.out.println(result[0]);  
		     String Token=result[0].toString();
		     map.put("linkJump", skipPath+Token);
		     client.destroy();
 		} catch (Exception e) {
 			client.destroy();
			 e.printStackTrace();
		}
		
         return map;
     }

	/**
	 * ADC调用接口认证
	 * deng
	 * 2021-01-11
	 */
	@ApiOperation(value = "ADC调用接口认证")
	@PostMapping("/adcWebService")
	@ResponseBody
	public Map<String, Object> adcWebService(HttpServletRequest request,String pwd,String gxbUsername) {
		DESUtil des=new DESUtil("12345678");
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
		String username=usermap.get("USERNAME").toString();
		String password=new String (Encodes.decodeBase64(pwd),StandardCharsets.UTF_8);
		password=des.encryptStr(password);
		Map<String, Object> map=new HashMap<String, Object>();

		JaxWsDynamicClientFactory clientFactory = JaxWsDynamicClientFactory.newInstance();
		Client client = clientFactory.createClient("http://39.99.149.182:8080/ws/TokenApiService?wsdl");
		try {
			Object[] result = client.invoke("createToken", new Object[]{username,password,"YWNjbhZG13Ng",gxbUsername});
			System.out.println(result[0]);
			map = StringUtils.getStringToMap(result[0].toString());
			client.destroy();
		} catch (Exception e) {
			client.destroy();
			e.printStackTrace();
		}

		return map;
	}
	public static void main(String[] args) throws Exception {
		 /*JaxWsDynamicClientFactory clientFactory = JaxWsDynamicClientFactory.newInstance();
	     Client client = clientFactory.createClient("http://39.100.75.112:45053/services/TokenADCSerivce?wsdl");  
	     Object[] result;
		try {
			result = client.invoke("createADCToken", new Object[]{"adc","adc","VTAMSENTADC001"});
			System.out.println(result[0]);  
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/

		// Test createToken
		 DESUtil des=new DESUtil("12345678");
		//Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
		String username="GX100348";
		String password=des.encryptStr("Y*(qv63L");
		Map<String, Object> map=new HashMap<String, Object>();

		JaxWsDynamicClientFactory clientFactory = JaxWsDynamicClientFactory.newInstance();
//		Client client = clientFactory.createClient("http://192.168.125.165:9098/ws/TokenApiService?wsdl");
		Client client = clientFactory.createClient("http://192.168.125.123:7007/ws/TokenApiService?wsdl");
		try {
			Object[] result = client.invoke("createToken", new Object[]{username,password,"YWNjbhZG13Ng"});
			System.out.println(result[0]);
			map = StringUtils.getStringToMap(result[0].toString());
			client.destroy();
		} catch (Exception e) {
			client.destroy();
			e.printStackTrace();
		}
	}

}
