package com.adc.da.bs.other.service;

import com.adc.da.bs.other.dao.NewsDao;
import com.adc.da.bs.report.dao.ReportDao;
import com.adc.da.util.http.PageParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 推荐目录Service
 * zhong
 * 2018-3-22
 */
@Service
public class NewsService {

    @Autowired
    private NewsDao newsDao;
    @Autowired
    private ReportDao reportDao;

/*	public Map<String, Object> findMap(PageParam page, Map<String, Object> map) {
		Map<String, Object> remap = new HashMap<>();
        List<Map<String, Object>> list=newsDao.findPage(page,map);
        Long count=newsDao.findPageCount(map);
        remap.put("total", count);
        remap.put("rows", list);
		return remap;
	}*/

    /**
     * 从字典表查询NERDS的参数项目
     *
     * @param typeids
     * @param partId
     * @return
     *//*
	public List<Map<String, Object>> getNerdsParamItems(String partId) {
		 return this.nerdsDao.getNerdsParamItems(partId);
	}
	public List<Map<String, Object>> getNerdsParamData(String p_id,
			String p_model, String type) {
		return this.nerdsDao.getNerdsParamData(p_id,p_model,type);
	}
	public List<Map<String, Object>> getCollocations(String p_id,
			String p_model, String type) {
		return this.nerdsDao.getCollocations(p_id, p_model, type);
	}*/
    public Map<String, Object> indexlist(PageParam page, int[] typeids) {
        Map<String, Object> remap = new HashMap<>();
        for (int typeid : typeids) {
            List<Map<String, Object>> list = newsDao.indexlist(page, typeid, "");
            remap.put("news" + String.valueOf(typeid), list);
        }

        return remap;
    }

    public Map<String, Object> newslist(PageParam page, int type, String name) {
        Map<String, Object> remap = new HashMap<>();
        List<Map<String, Object>> list = newsDao.indexlist(page, type, name);
        Long count = newsDao.findPageCount(type, name);
        // remap.put("news", list);
        remap.put("total", count);
        remap.put("rows", list);
        return remap;
    }

    public int clickcount(String iD) {
        Map<String, Object> remap = new HashMap<>();
        int i = newsDao.clickcount(iD);
        return i;
    }

    /**
     * @param @param  page
     * @param @param  type
     * @param @param  string
     * @param @return 设定文件
     * @Title: newsIndexGroupByType
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午5:48:31
     */
    public Map<String, Object> newsIndexGroupByType(PageParam page, String type,
                                                    String string) {
        List<Map<String, Object>> list = newsDao.newsIndexList(type);
        List<Map<String, Object>> countList = newsDao.newsIndexCountList(type);
        List<Map<String, Object>> zcpdfList = reportDao.PdfIndexList("'5'", 3);//整车资讯
        List<Map<String, Object>> lbjpdfList = reportDao.PdfIndexList("'6'", 3);//零部件资讯
        Map<String, Object> zc_lbj = new HashMap<>();
        zc_lbj.put("zc", zcpdfList);
        zc_lbj.put("lbj", lbjpdfList);
        List<Map<String, Object>> pdfcountList = reportDao.PdfIndexCountList("'5','6'");

        Map<String, Object> remap = new HashMap<>();
        remap.put("zc_lbj", zc_lbj);
        remap.put("zc_lbjcount", pdfcountList);
        remap.put("hy_xny", list);
        remap.put("hy_xnycount", countList);

        return remap;
    }

    /**
     * @param @param  iD
     * @param @return 设定文件
     * @return int    返回类型
     * @Title: addclick
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午4:52:13
     */
    public int addclick(String iD) {
        int i = reportDao.addclick(iD);
        return i;
    }


}
