package com.adc.da.bs.param.rest;

import com.adc.da.bs.login.service.LoginService;
import com.adc.da.bs.param.dao.ParamDao;
import com.adc.da.bs.param.entity.SearchProductParams;
import com.adc.da.bs.param.service.ParamService;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.util.utils.GsonUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 车型参数Controller
 * zhong
 * 2018-3-14
 */

@RestController
@RequestMapping(value = "/${restPath}/param")
@Api(description = "车型参数")
public class ParamController {

    @Autowired
    private ParamService paramService;
    @Autowired
    private LoginService loginService;
    @Autowired
    private ParamDao paramDao;

    private SearchProductParams searchProductParams;

    /**
     * 车型参数列表
     * zhong
     * 2018-3-14
     */
    @ApiOperation(value = "按pc列表_行业")
    @PostMapping("/list")
    @ResponseBody
    public Map<String, Object> findList(HttpServletRequest request, PageParam page, String pc, String cpsb, String rlzl, String qymc) {
//		public ResponseMessage<String> findList(PageParam page,String pc) {
        Map<String, Object> pageMap = new HashMap();
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();


        //根据标记位判断是否进行二次弹框;
        //select * from CHECKFLAG   -- Y 表示弹框二次校验  N表示 不弹框
        String result = null;
        String LoginFlagInfo = paramDao.findLoginFlagInfo();
        if (null != LoginFlagInfo && "N".equals(LoginFlagInfo)) {
            result = "Y";
        } else {
            result = usermap.get("RESULT") == null ? "N" : usermap.get("RESULT").toString();
        }
        if (result == null || "N".equals(result) || "D".equals(result)) {
            result = loginService.getresult(qyid);
        }
        //获取控制是否显示全行业的批次数据
        String pcFlag = paramDao.findPcInfo();

        if (result != null && "Y".equals(result)) {
            if (pc == null || "undefined".equals(pc) || "".equals(pc)) {
//				 pc= String.valueOf(Integer.parseInt(pcFlag)+1);//20210319：因不传pc默认会取最新批次，导致341可以全部企业都能看到，领先装备中心公开行业数据，所以临时加上
            }
            if (pcFlag.equals(pc)) {
//				String group=paramService.findGroup(qyid);
//				qyid="".equals(group)?qyid:group;
                pageMap = paramService.findMap(page, pc, qyid, cpsb, rlzl, qymc);
            } else {
                pageMap = paramService.findMap(page, pc, "", cpsb, rlzl, qymc);
            }
            //恢复查全行业20210118
//			pageMap = paramService.findMap(page, pc, "", cpsb, rlzl,qymc);
        }
        pageMap.put("result", result);//D或者N需等待同步数据

        // 获取企业名称
        String qy_mc = usermap.get("NAME").toString();
        pageMap.put("qymc", qy_mc);//提供当前企业的企业名称

        return pageMap;
        //return Result.success(GsonUtil.toJson(pageMap));
    }
    /**
     * 车型参数列表
     * zhong
     * 2018-3-14
     */
	/*@ApiOperation(value = "按产品名称列表_本企业")
    @PostMapping("/listbyUser")
    @ResponseBody
    public Map<String, Object> findListbyUser(HttpServletRequest request,PageParam page,String name,String pc) {
		Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
    	String qyid=usermap.get("USERNAME").toString();
		if(pc==""||"undefined".equals(pc)) return null;
    	Map<String,Object> pageMap =paramService.findMapbyUser(page,name,"", pc,qyid);
        return pageMap;
    }*/

    /**
     * 车型参数列表
     * zhong
     * 2018-3-14
     */
    @ApiOperation(value = "详细")
    @PostMapping("/paramdetail")
    @ResponseBody

    public Map<String, Object> paramdetail(String xh, String type, String dpid) {
//		public ResponseMessage<String> findList(PageParam page,String pc) {
        if ("2".equals(type) && dpid != null && !"".equals(dpid)) {
            xh = paramService.getdpxh(dpid);
        }
        Map<String, Object> pageMap = paramService.paramdetail(xh, type);
        return pageMap;
    }

    /**
     * 车型参数列表
     * zhong
     * 2018-3-14
     */
    @ApiOperation(value = "按xh列表_行业")
    @PostMapping("/findxhList")
    @ResponseBody
    public Map<String, Object> findxhList(HttpServletRequest request, PageParam page, String xh, String pc, String cpsb, String rlzl, String qymc) {
        //获取控制是否显示全行业的批次数据
        String pcFlag = paramDao.findPcInfo();
        Map<String, Object> pageMap = new HashMap();
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();
        String result = usermap.get("RESULT").toString();//是否拥有查询公告参数密码
        if (result == null || "N".equals(result) || "D".equals(result)) {
            result = loginService.getresult(qyid);
        }
        if (result != null && "Y".equals(result)) {
            request.getSession().setAttribute("req", xh);
            request.getSession().setAttribute("pc", pc);
            //恢复查全行业20210118
//			pageMap =paramService.findxhPage(page, xh,"",pc, cpsb, rlzl,qymc);
            if (pcFlag.equals(pc)) {
                // 针对339批次
                //集团用户查询集团车型
//			String group=paramService.findGroup(qyid);
//			qyid="".equals(group)?qyid:group;
                pageMap = paramService.findxhPage339(page, xh, "", qyid, pcFlag);
            } else {
                pageMap = paramService.findxhPage(page, xh, "", pc, cpsb, rlzl, qymc);

            }
        }
        pageMap.put("result", result);//D或者N需等待同步数据

        // 获取企业名称
        String qy_mc = usermap.get("NAME").toString();
        pageMap.put("qymc", qy_mc);//提供当前企业的企业名称

        return pageMap;
    }

    /**
     * 车型参数列表
     * zhong
     * 2021-1-5
     */
    @ApiOperation(value = "按产品名称列表_本企业2021")
    @PostMapping("/listbyUser")
    @ResponseBody
    public Map<String, Object> findnameListbyUser(HttpServletRequest request, PageParam page, String name, String pc, String rlzl, String cpsb) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();
        if (pc == null || pc == "" || "undefined".equals(pc)) {
            throw new AdcDaBaseException("批次不能为空！");
        }
        ;
        Map<String, Object> pageMap = paramService.findMapbyUser(page, name, "", pc, qyid, rlzl, cpsb);
        return pageMap;
    }

    /**
     * 车型参数列表
     * zhong
     * 2021-1-5
     */
    @ApiOperation(value = "按型号列表_本企业2021")
    @PostMapping("/findxhListbyUser")
    @ResponseBody
    public Map<String, Object> findxhListbyUser(HttpServletRequest request, PageParam page, String xh, String pc, String rlzl, String cpsb) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();
        request.getSession().setAttribute("req", xh);
        Map<String, Object> pageMap = paramService.findMapbyUser(page, "", xh, pc, qyid, rlzl, cpsb);
        return pageMap;
    }

    /**
     * 车型参数列表
     * zhong
     * 2018-3-14
     */
    @ApiOperation(value = "按qymc列表_行业")
    @PostMapping("/findnameList")
    @ResponseBody
    public Map<String, Object> findnameList(HttpServletRequest request, PageParam page, String qymc, String pc, String cpsb, String rlzl, String cpmc) {
        //获取控制是否显示全行业的批次数据
        String pcFlag = paramDao.findPcInfo();
        try {
            qymc = URLDecoder.decode(qymc, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        Map<String, Object> pageMap = new HashMap();
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();
        String result = usermap.get("RESULT").toString();
        if (result == null || "N".equals(result) || "D".equals(result)) {
            result = loginService.getresult(qyid);
        }
        if (result != null && "Y".equals(result)) {
            //恢复查全行业20210118
//			pageMap =paramService.findnamePage(page, qymc,"",pc, cpsb, rlzl,cpmc);
            if (pcFlag.equals(pc)) {
                // 针对339批次
                //集团用户查询集团车型
//			String group=paramService.findGroup(qyid);
//			qyid="".equals(group)?qyid:group;
                pageMap = paramService.findnamePage339(page, qymc, "", qyid, pcFlag, cpsb, rlzl, cpmc);
            } else {
                pageMap = paramService.findnamePage(page, qymc, "", pc, cpsb, rlzl, cpmc);

            }
            // 针对339批次
            //集团用户查询集团车型
//			String group=paramService.findGroup(qyid);
//			qyid="".equals(group)?qyid:group;
        }
        pageMap.put("result", result);//D或者N需等待同步数据

        // 获取企业名称
        String qy_mc = usermap.get("NAME").toString();
        pageMap.put("qymc", qy_mc);//提供当前企业的企业名称

        return pageMap;

    }

    @ApiOperation(value = "查询本企业品牌、燃料种类列表")
    @PostMapping("/findBrand")
    @ResponseBody
    public Map<String, Object> findBrandFuel(HttpServletRequest request) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();
        Map<String, Object> pageMap = paramService.findBrandFuel(qyid);
        return pageMap;

    }

    @ApiOperation(value = "查询行业品牌、燃料种类列表")
    @PostMapping("/findBrandFuelPc")
    @ResponseBody
    public Map<String, Object> findBrandFuelPc(HttpServletRequest request) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        Map<String, Object> pageMap = paramService.findBrandFuelPc("");
        return pageMap;

    }

    /**
     * 车型参数列表
     * zhong
     * 2019-2-28
     */
    @ApiOperation(value = "高级检索")
    @PostMapping("/findMoreList")
    @ResponseBody
    public Map<String, Object> findMoreList(HttpServletRequest request, PageParam page, String searchProductParams) {
        if (searchProductParams.length() <= 3) {
            Map<String, Object> Map = new HashMap();
            return Map;
        }
        SearchProductParams spp = GsonUtil.json2T(searchProductParams, SearchProductParams.class);
        //恢复查全行业20210118
        Map<String, Object> pageMap = paramService.findMoreList(page, spp);

        // 获取企业名称
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qymc = usermap.get("NAME").toString();
        String qyid = usermap.get("USERNAME").toString();
        //集团用户查询集团车型
//		String group=paramService.findGroup(qyid);
//		qyid="".equals(group)?qyid:group;
////		Map<String,Object> pageMap =paramService.findMoreList339(page, spp, qyid,pcfalg);

        pageMap.put("qymc", qymc);//提供当前企业的企业名称

        return pageMap;

    }

    /**
     * 企业数量统计
     * zhong
     * 2018-3-14
     */
    @ApiOperation(value = "详细")
    @PostMapping("/paramcount")
    @ResponseBody

    public Map<String, Object> paramcount(HttpServletRequest request) {
//		public ResponseMessage<String> findList(PageParam page,String pc) {
        Map<String, Object> pageMap = paramService.paramcount();
        return pageMap;
    }

    public SearchProductParams getSearchProductParams() {
        return searchProductParams;
    }

    public void setSearchProductParams(SearchProductParams searchProductParams) {
        this.searchProductParams = searchProductParams;
    }

    @ApiOperation(value = "按型号查找产品名称列表")
    @PostMapping("/findCpmcByCpxh")
    @ResponseBody
    public ResponseMessage<List<Map<String, Object>>> findCpmcByCpxh(HttpServletRequest request, String cpxh, String pc) {
        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
        String qyid = usermap.get("USERNAME").toString();
        List<Map<String, Object>> pageMap = paramService.findCpmcByCpxh(cpxh, pc, qyid);
        return Result.success(pageMap);
    }
}
