package com.adc.da.bs.param.service;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.adc.da.bs.param.dao.ParamChartsDao;
import com.adc.da.util.utils.RedisUtils;

/**
 * 车型参数Service
 * ADC_ZH
 * 2021-1-14
 */
@Service
public class ParamChartsService {
	
	@Autowired
	private ParamChartsDao paramChartsDao;

    @Autowired
    private RedisUtils redisUtils;
	/**   
	 * @Title: lineCharts   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午4:26:35 
	*/   
	public Map<String, Object> lineCharts(String qyid) {
		Map<String, Object> map = new HashMap<>();
		long min=60*24;
		if(!redisUtils.exists("lineCharts_lastY_"+qyid)){
            List<Map<String, Object>> lastY=paramChartsDao.lineCharts(qyid,1);
            redisUtils.set("lineCharts_lastY_"+qyid, lastY, min, TimeUnit.MINUTES);
        	map.put("lastY",  lastY);
        }else{
        	map.put("lastY",  redisUtils.get("lineCharts_lastY_"+qyid));
        }
		if(!redisUtils.exists("lineCharts_thisY_"+qyid)){
        	List<Map<String, Object>> thisY=paramChartsDao.lineCharts(qyid,0);
        	redisUtils.set("lineCharts_thisY_"+qyid, thisY, min, TimeUnit.MINUTES);
        	map.put("thisY",  thisY);
        } else{
        	map.put("thisY",  redisUtils.get("lineCharts_thisY_"+qyid));
        }
		map.put("result", "0");
		return map;
	}

	/**   
	 * @Title: barCharts   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件   
 	 * @author ADC_ZH 
	 * @date 上午9:48:20 
	*/   
	public Map<String, Object> barCharts() {
		Map<String, Object> map = new HashMap<>();
		if(!redisUtils.exists("barCharts_qymc")){
             List<Map<String, Object>> qymc=paramChartsDao.barCharts("企业名称");
             redisUtils.set("barCharts_qymc", qymc);
         	map.put("qymc", qymc);        	
		}else{
        	map.put("qymc", redisUtils.get("barCharts_qymc"));        	
        } 
		if(!redisUtils.exists("barCharts_cpsb")){
			List<Map<String, Object>> cpsb=paramChartsDao.barCharts("产品商标");
            redisUtils.set("barCharts_cpsb", cpsb);
        	map.put("cpsb", cpsb);
        }else{
        	map.put("cpsb", redisUtils.get("barCharts_cpsb"));
        	
        }
		map.put("result", "0");
		return map;
	}

	/**   
	 * @Title: compare   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午1:47:03 
	*/   
	public Map<String, Object> compare(String qyid) {
		Map<String, Object> map = new HashMap<>();
		List<Map<String, Object>> m1=paramChartsDao.compare(qyid,1);
		List<Map<String, Object>> m2=paramChartsDao.compare(qyid,2);
		List<Map<String, Object>> m13=paramChartsDao.compare(qyid,13);
		float i1=m1.get(0).get("COU")==null?0:Integer.parseInt(m1.get(0).get("COU").toString());
		float i2=m2.get(0).get("COU")==null?0:Integer.parseInt(m2.get(0).get("COU").toString());
		float i13=m13.get(0).get("COU")==null?0:Integer.parseInt(m13.get(0).get("COU").toString());
		DecimalFormat fnum = new DecimalFormat("##0.00"); 
		
		
		if(i1-i2<0){ 
			String hb=fnum.format((i2-i1)/i2);
			map.put("hb", "-"+hb);
		}else{
			String hb="1"; 
			if(i2!=0){
				 hb=fnum.format((i1-i2)/i2); 
			}
			if(i1==0){
				hb="0"; 
			}
			map.put("hb", hb);
		} 
		if(i1-i13<0){ 
			String tb=fnum.format((i13-i1)/i13); 
			map.put("tb", "-"+tb);
		}else{
			String tb="1"; 
			if(i13!=0){
				tb=fnum.format((i1-i13)/i13); 
			}
			if(i13==0){
				tb="0"; 
			}
			map.put("tb", tb);
		}

		List<Map<String, Object>> my1=paramChartsDao.compareByYear(qyid,1);
		List<Map<String, Object>> my13=paramChartsDao.compareByYear(qyid,13);
		float y1=my1.get(0).get("COU")==null?0:Integer.parseInt(my1.get(0).get("COU").toString());
		String  yyyymm=my1.get(0).get("YYYYMM")==null?"": my1.get(0).get("YYYYMM").toString() ;
		float y13=my13.get(0).get("COU")==null?0:Integer.parseInt(my13.get(0).get("COU").toString());
		if(y1-y13<0){ 
			String tb=fnum.format((y13-y1)/y13); 
			map.put("YearTb", "-"+tb);
		}else{
			String tb="1"; 
			if(y13!=0){
				tb=fnum.format((y1-y13)/y13); 
			}
			if(y1==0){
				tb="0"; 
			}
			map.put("YearTb", tb);
		}
		map.put("result", "0");
		map.put("m_count", i1);
		map.put("y_count", y1);
		map.put("yyyymm", yyyymm);
		
		return map;
	}

	
}
