package com.adc.da.bs.policy.rest;

import com.adc.da.bs.policy.service.PolicyService;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author AnYuShi
 * @description 政策研究
 * @date create at 16:29 2018/3/20
 * @modified by
 */
@RestController
@RequestMapping(value = "/${restPath}/policy")
@Api(description = "政策研究查询")
public class PolicyController {
    @Autowired
    private PolicyService policyService;

    /**
     * @describtion pdf列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "政策研究查询列表")
    @GetMapping("/policylist")
    @ResponseBody
    public ResponseMessage<Map<String, Object>> policyList() {
        try {
            Map<String, Object> maps = policyService.policyList();
            return Result.success(maps);
        } catch (Exception e) {
            return Result.error(e.getMessage());
        }

    }
    
    /**
     * @describtion pdf列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "政策研究查询列表")
    @PostMapping("/findListByPage")
    @ResponseBody
    public  Map<String, Object> findListByPage(HttpServletRequest request,PageParam page, String type, String keyName,String fproperty) { 
    	
    	Map<String,Object> pageMap =policyService.findListByPage(page, type, keyName,fproperty);
        return pageMap; 
		}
    
    /**
     * @describtion 删除
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "删除")
    @PostMapping("/delete")
    @ResponseBody
    public  boolean  delete(HttpServletRequest request,  String id ) {  
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
		if (!"61077".equals(usermap.get("ID").toString()) || !"adc".equals(usermap.get("USERNAME").toString())) {
			return false;
        }else{         	
        	return policyService.delete(id); 
        }
	}
}
