package com.adc.da.bs.policy.service;

import com.adc.da.bs.policy.dao.PolicyDao;
import com.adc.da.util.http.PageParam;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Service
public class PolicyService {
    @Autowired
    private PolicyDao policyDao;

    public Map<String, Object> policyList() {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list = policyDao.policyList("3");
        map.put("list", list);
        return map;
    }

    @Transactional
    public int uploadFile(Map<String, Object> map) {
        int i = policyDao.uploadFile(map);
        return i;
    }

	/**   
	 * @Title: findListByPage   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param type
	 * @param @param keyName
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @param fPROPERTY 
	 * @date 上午10:53:19 
	*/   
	public Map<String, Object> findListByPage(PageParam page, String type,
			String keyName, String fproperty) {
		Map<String, Object> result = new HashMap<>();
		Long count = policyDao.findTotalCount(page, type, keyName,fproperty);
		List<Map<String, Object>> list = policyDao.findListByPage(page, type, keyName,fproperty);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}

	/**   
	 * @Title: delete   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return boolean    返回类型   
	 * @author ADC_ZH 
	 * @date 下午6:00:09 
	*/   
	public boolean delete(String id) {
		// TODO Auto-generated method stub
		return policyDao.delete(id);
	}
}