package com.adc.da.bs.report.dao;

import com.adc.da.util.exception.AdcDaBaseException;
import lombok.extern.slf4j.Slf4j;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.util.Map;

/**
 * @author 韩磊
 * @date 2019/3/21 13:42
 */
@Slf4j
@Component
public class AnalyzeReportDao {
    protected final EntityManager entityManager;

    @Autowired
    public AnalyzeReportDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }

    public List<Map<String, Object>>analyzeReportIndex(String FPROPERTY, int i) {
        StringBuilder sql = new StringBuilder();
        sql.append(" SELECT * from(");
        sql.append(" SELECT TAFM.FILE_ID,TAFM.TITLE ,TAFM.AUTHOR,TAFM.PAGE_NUM,TAFM.CHARTS_NUM,");
        sql.append(" TAFM.UPDATE_DATE ,TAFM.UPDATE_ID,TAFM.FURL,TAFM.FTYPE,TAFM.PIC_ID,TAFM.CONTENT,TAFM.TOP,TAPM.PURL ");
        sql.append(" FROM NERDS.TS_ADCBS_FILE_MANAGERMENT  TAFM");
        sql.append(" left join NERDS.TS_ADCBS_PICTURE_MANAGERMENT  TAPM");
        sql.append(" on TAFM.PIC_ID=TAPM.PIC_ID  ");
        sql.append(" WHERE TAFM.ENABLE='0' AND TAFM.FPROPERTY = '"+FPROPERTY+"'");
        sql.append(" AND TAFM.TOP = '1' ");
        sql.append(" ORDER BY TAFM.UPDATE_DATE DESC ");
        sql.append(" )WHERE ROWNUM<= "+i);
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }

    public List<Map<String, Object>> analyzeReportList(String property) {
        StringBuilder sql = new StringBuilder();
        sql.append("  SELECT ROWNUM,TAFM.FILE_ID,TAFM.TITLE ,TAFM.AUTHOR,TAFM.PAGE_NUM,TAFM.CHARTS_NUM,");
        sql.append(" TAFM.UPDATE_DATE ,TAFM.UPDATE_ID,TAFM.FURL,TAFM.FTYPE,TAFM.PIC_ID,TAFM.CONTENT,TAFM.TOP,TAPM.PURL ");
        sql.append(" FROM NERDS.TS_ADCBS_FILE_MANAGERMENT  TAFM");
        sql.append(" left join NERDS.TS_ADCBS_PICTURE_MANAGERMENT  TAPM");
        sql.append(" on TAFM.PIC_ID=TAPM.PIC_ID  ");
        sql.append(" WHERE TAFM.ENABLE='0' AND TAFM.FPROPERTY = ? ");
        sql.append("   ORDER BY TAFM.UPDATE_DATE DESC  ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1, property);
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }








    public int uploadFile(Map<String, Object> map,Integer picId) {
        int i;
        String inFileSql =
                " INSERT INTO NERDS.TS_ADCBS_FILE_MANAGERMENT (FILE_ID,TITLE, PIC_ID, AUTHOR ,PAGE_NUM, " +
                        "CHARTS_NUM, FNAME, FURL, FSIZE,CONTENT,TOP,FTYPE,FSUFFIX, FPROPERTY,ENABLE," +
                        "CREATE_DATE,CREATE_ID,UPDATE_DATE,UPDATE_ID)" +
                        " VALUES (NERDS.retrieval_seq.nextval, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,  ";
        if(map.get("uploadDate")!=null && !"".equals("uploadDate")){
        	inFileSql +=" to_date('"+map.get("uploadDate")+"','YYYY-MM-DD'), ?, to_date('"+map.get("uploadDate")+"','YYYY-MM-DD') ,?) ";
        }else{        	
        	inFileSql +=" SYSDATE, ?, SYSDATE ,?) ";
        }
        Query inFileQuery = entityManager.createNativeQuery(inFileSql);
        inFileQuery.setParameter(1, map.get("title"));
        inFileQuery.setParameter(2, picId);
        inFileQuery.setParameter(3, map.get("author"));
        inFileQuery.setParameter(4, map.get("page"));
        inFileQuery.setParameter(5, map.get("charts"));
        inFileQuery.setParameter(6, map.get("fname"));
        inFileQuery.setParameter(7, map.get("furl"));
        inFileQuery.setParameter(8, map.get("fsize"));
        inFileQuery.setParameter(9, map.get("content"));
        inFileQuery.setParameter(10, map.get("top"));
        inFileQuery.setParameter(11, map.get("ftype"));
        inFileQuery.setParameter(12, map.get("fsuffix"));
        inFileQuery.setParameter(13, map.get("fproperty"));
        inFileQuery.setParameter(14, 0);
        inFileQuery.setParameter(15, map.get("userId"));
        inFileQuery.setParameter(16, map.get("userId"));

        i = 0;
        try {
            i = inFileQuery.executeUpdate();
        } catch (Exception e) {
            log.error(e.toString());
            throw new AdcDaBaseException("文件存储插入失败：" + map.get("fname"));
        }

        return i;
    }

    public Integer uploadPic(Map<String, Object> map) {
        //获取pic的Id
        String idSql = "SELECT NERDS.retrieval_seq.nextval from dual";
        Query idQuery = entityManager.createNativeQuery(idSql);
        Integer picId = Integer.parseInt(idQuery.getSingleResult().toString());
        String inPicSql =
                " INSERT INTO NERDS.TS_ADCBS_PICTURE_MANAGERMENT (PIC_ID,PNAME, PURL, PTYPE ,PSIZE, PSUFFIX, " +
                        "PPROPERTY, ENABLE, CREATE_DATE,CREATE_ID,UPDATE_DATE,UPDATE_ID )" +
                        " VALUES (?, ?, ?, ?, ?, ?, ? , ?, SYSDATE, ?, SYSDATE ,?) ";
        Query inPicQuery = entityManager.createNativeQuery(inPicSql);
        inPicQuery.setParameter(1, picId);
        inPicQuery.setParameter(2, map.get("pname"));
        inPicQuery.setParameter(3, map.get("purl"));
        inPicQuery.setParameter(4, map.get("ptype"));
        inPicQuery.setParameter(5, map.get("psize"));
        inPicQuery.setParameter(6, map.get("psuffix"));
        inPicQuery.setParameter(7, map.get("pproperty"));
        inPicQuery.setParameter(8, 0);
        inPicQuery.setParameter(9, map.get("userId"));
        inPicQuery.setParameter(10, map.get("userId"));

        int i = 0;
        try {
            i = inPicQuery.executeUpdate();
        } catch (Exception e) {
            log.error(e.toString());
            throw new AdcDaBaseException("封面图片存储失败：" + map.get("pname"),e.toString());
        }
        return picId;
    }
}
