package com.adc.da.bs.report.service;

import com.adc.da.bs.report.dao.ReportDao;
import com.adc.da.util.http.PageParam;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author ZhengZhiwei
 * @description 检测报告查询
 * @date create at 16:28 2018/3/20
 * @modified by
 */
@Service
public class ReportService {
    @Autowired
    private ReportDao reportDao;



  /**
   * @describtion TODO 检测报告 分页查询
   * @param
   * @author ZhengZhiwei
   * @date create at 21:47 2018/3/21
   * @modified by
   */
    public Map<String, Object> findMapByPage(PageParam page, String param) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list=reportDao.findPage(page,param);
        Long count=reportDao.findPageCount(param);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }


    /**
     * @describtion TODO 上传分析报告
     * @author Zhong
     */
    @Transactional
public int upPdf(Map<String, Object> map) {
	int i=reportDao.upPdf(map);
	return i;
}


	public Map<String, Object> PdfList(PageParam page, String type) {
		Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list=reportDao.PdfList(page,type);
        Long count=reportDao.PdfListCount(type);
        map.put("total", count);
        map.put("rows", list);
        return map;
	}


	public Map<String, Object> PdfIndex() {
		Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> ggcx=reportDao.PdfIndex("1",4);//公告车型分析
        List<Map<String, Object>> xnycx=reportDao.PdfIndex("2",4);//新能源车型分析
        List<Map<String, Object>> hysj=reportDao.PdfIndex("3",4);//行业数据分析
        map.put("ggcx", ggcx);
        map.put("xnycx", xnycx);
        map.put("hysj", hysj);
        return map;
	}


	public Map<String, Object> MainPageNews() {
		Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> ggcx=reportDao.PdfIndex("5",4);//zuixinzix
        map.put("ggcx", ggcx);
        return map;
	}

	public Map<String, Object> dailylist(PageParam page, int type, String name) {
		Map<String, Object> remap = new HashMap<>();
		List<Map<String, Object>> list=reportDao.dailylist(page,type,name);
		Long count=reportDao.dailylistPageCount(type,name);
		// remap.put("news", list);
		 remap.put("total", count);
	     remap.put("rows", list);
		 return remap;
	}
	public Map<String, Object> NewsContents(String type,String num) {
		 
        Map<String, Object> ggcx=reportDao.NewsContents(type,num);
        
        return ggcx;
	}


	/**   
	 * @Title: delete   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return boolean    返回类型   
	 * @author ADC_ZH 
	 * @date 下午6:21:16 
	*/   
	@Transactional
	public boolean delete(String id) {
		// TODO Auto-generated method stub
		return reportDao.delete(id);
	}


}
