package com.adc.da.bs.resourceSharing.dao;

import lombok.extern.slf4j.Slf4j;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.util.Map;

/**
 * @author hanlei
 * @date 2019/3/21 13:42
 */
@Slf4j
@Component
public class MeetingDao {
    protected final EntityManager entityManager;

    @Autowired
    public MeetingDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }

    public List<Map<String, Object>> meetingList(String property) {
        StringBuilder sql = new StringBuilder();
        sql.append("  SELECT ROWNUM,TAFM.FILE_ID,TAFM.TITLE ,TAFM.AUTHOR,TAFM.PAGE_NUM,TAFM.CHARTS_NUM,");
        sql.append(" TAFM.UPDATE_DATE ,TAFM.UPDATE_ID,TAFM.FURL,TAFM.FTYPE,TAFM.PIC_ID,TAFM.CONTENT,TAFM.TOP,TAPM.PURL ");
        sql.append(" FROM NERDS.TS_ADCBS_FILE_MANAGERMENT  TAFM");
        sql.append(" left join NERDS.TS_ADCBS_PICTURE_MANAGERMENT  TAPM");
        sql.append(" on TAFM.PIC_ID=TAPM.PIC_ID  ");
        sql.append(" WHERE TAFM.ENABLE='0' AND TAFM.FPROPERTY = ? ");
        sql.append("   ORDER BY TAFM.UPDATE_DATE DESC  ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1, property);
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }
}
