package com.adc.da.bs.webservice.provider;

import com.adc.da.bs.login.dao.LoginDao;
import com.adc.da.bs.webservice.dao.ZbzxGgcsDao;
import com.adc.da.bs.webservice.schedule.AsyncService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

@RestController
public class AsyncRest {
    private static Logger logger = LoggerFactory.getLogger(AsyncRest.class);

    @Autowired
    private AsyncService asyncService;

    @Autowired
    private ZbzxGgcsDao zbzxGgcsDao;

    @Autowired
    private LoginDao loginDao;

    // 线程开启以下爬数任务
    // Step1 张宏的爬数
    // Step2 青洋导数
    // Step3 照片导入
    // Step4 同步照片导数据中心
    // Step5 以上四步没有问题，状态ret_users置为Y
    public String main(Map<String, Object> map) {
        try {
            Future<String> createStep = asyncService.execStep(map);
            // 设置10分钟
            createStep.get(10, TimeUnit.MINUTES);

            Boolean result = false;
            while (!result) {
                Thread.sleep(1000);
                if (createStep.isDone()) {
                    String stepResult = createStep.get();
                    logger.info("***** 线程跑完", stepResult);
                    // Step5 状态ret_users置为Y
                    if ("Y".equals(stepResult)) {
                        logger.info("****** STEP 5：updateRetUserStatusY START", map.get("username"));
                        loginDao.updateRetUserStatusY(map);
                        logger.info("****** STEP 5：updateRetUserStatusY END", map.get("username"));
                    }
                    result=true;
                    break;
                }

            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
            logger.info("******* execStep error:"+e.getMessage());
        }
        logger.info("******* execStep game over!!!");
        System.out.println("execStep game over!!!");
        return "success";
    }
}
