package com.adc.da.bs.webservice.provider;

import com.adc.da.bs.login.dao.LoginDao;
import com.adc.da.bs.webservice.schedule.AsyncService;
import com.adc.da.bs.webservice.server.TokenApiService;
import com.adc.da.bs.webservice.server.ZbzxGgcsService;
import com.adc.da.bs.webservice.util.DESUtil;
import com.adc.da.util.utils.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.jws.WebService;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.Future;

@Component
@WebService(name = "TokenApiService",
        targetNamespace = "http://adc.da/webservice/server",
        endpointInterface = "com.adc.da.bs.webservice.server.TokenApiService",
        portName = "adc")
public class TokenApiServiceImpl implements TokenApiService {

    private static Logger logger = LoggerFactory.getLogger(TokenApiServiceImpl.class);

    @Autowired
    private ZbzxGgcsService zbzxGgcsService;

    @Autowired
    private AsyncService asyncService;

    @Override
    public String createToken(String adcusername, String password, String key, String gxbusername) {
        Map<String, Object> remap = new HashMap<>();
        try {
            logger.info("******findMap before gxbusername" + gxbusername);
            logger.info("******findMap before adcusername" + adcusername);

            logger.info("******findMap before password" + password);
            logger.info("******findMap before key" + key);

            remap =loginDao.findMap(adcusername);

            System.out.println("******findMap after:"+password);
            DESUtil des=new DESUtil("12345678");
            password=des.decryptStr(password);
            System.out.println("decryptStr after password:"+password);

            // 设置remap里密码
            remap.put("gxbpassword", password);

            remap.put("gxbusername", gxbusername);

            Map<String,Object> map = new HashMap<>(3);
            if("YWNjbhZG13Ng".equals(key) && StringUtils.isNotBlank(password)) {

                System.out.println("******验证二次登录用户名密码******"+gxbusername);
                // 验证二次登录用户名密码
                map = zbzxGgcsService.login(gxbusername, password);
                // 把通过接口传过来的参数也保存到这里 adcusername和pwd以及name
                map.put("username", adcusername);
                map.put("password", password);
                map.put("name", remap.get("NAME").toString());

                // 登录成功
                if(map != null && "Y".equals(map.get("result").toString())) {

                    System.out.println("******验证二次登录登录成功******");

                    // Step0 ret_users 先设定成D 保存密码
                    loginDao.updateRetUserStatusD(remap);

                    System.out.println("******验证二次登录保存密码******");

                    // 异步调用其他步骤工作
                    System.out.println("调用异步前时间："+System.currentTimeMillis());
                    Future<String> createStep = asyncService.execStep(map);
                    System.out.println("直接返回时间："+System.currentTimeMillis());
                    // 先返回校验后结论
                    return StringUtils.getMapToString(map);

                } else if(map != null && "N".equals(map.get("result"))){
                    return StringUtils.getMapToString(map);
                } else {
                    return null;
                }
            } else {
                map.put("result","N");
                map.put("account","N/A1");
                return StringUtils.getMapToString(map);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        remap.put("result","N");
        remap.put("account","N/A2");
        return StringUtils.getMapToString(remap);
    }

    @Autowired
    private LoginDao loginDao;


    /**
     *
     * Map转String
     * @param map
     * @return
     */
    private static String getMapToString(Map<String,Object> map){
        Set<String> keySet = map.keySet();
        //将set集合转换为数组
        String[] keyArray = keySet.toArray(new String[keySet.size()]);
        //给数组排序(升序)
        Arrays.sort(keyArray);
        //因为String拼接效率会很低的，所以转用StringBuilder
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < keyArray.length; i++) {
            // 参数值为空，则不参与签名 这个方法trim()是去空格
            if ((String.valueOf(map.get(keyArray[i]))).trim().length() > 0) {
                sb.append(keyArray[i]).append(":").append(String.valueOf(map.get(keyArray[i])).trim());
            }
            if(i != keyArray.length-1){
                sb.append(",");
            }
        }
        return sb.toString();
    }

}