package com.adc.da.communal.visittimes.cache;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 访问次数缓存
 *
 * @author 韩磊
 * @version V1.0
 * @date 2019-05-21 11:29
 **/
public class VisitTimesCache {

    private static final Map<String, Integer> VISIT_TIMES_MAP = new ConcurrentHashMap<>();

    public static int get(String key) {
        return VISIT_TIMES_MAP.get(key);
    }

    public static int add(String key) {
        int times = get(key);
        VISIT_TIMES_MAP.put(key, times + 1);
        return times + 1;
    }

    public static void put(String key, Integer value) {
        VISIT_TIMES_MAP.put(key, value);
    }
}
