package com.adc.da.communal.visittimes.dao;

import com.adc.da.communal.visittimes.vo.FileVisitTimesVO;
import lombok.extern.slf4j.Slf4j;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.util.Map;

/**
 * @author 韩磊
 * @version V1.0
 * @date 2019-05-21 11:58
 **/
@Slf4j
@Component
public class VisitTimesDao {

    protected final EntityManager entityManager;

    @Autowired
    public VisitTimesDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }

    public List<Map<String, String>> getAllFileVisitTimes() {
        StringBuilder sql = new StringBuilder();
        sql.append("  SELECT FURL as furl,NVL(SP1,'0') as times FROM NERDS.TS_ADCBS_FILE_MANAGERMENT");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, String>> list = query.getResultList();
        return list;
    }

    public int saveVisitTimes(String key, int times) {
        String updatePointSql = " UPDATE NERDS.TS_ADCBS_FILE_MANAGERMENT SET SP1 = ? WHERE FURL = ? ";
        Query updateQuery = entityManager.createNativeQuery(updatePointSql);
        updateQuery.setParameter(1, String.valueOf(times));
        updateQuery.setParameter(2, key);
        int i = updateQuery.executeUpdate();
        return i;
    }
}
