package com.adc.da.communal.visittimes.init;

import com.adc.da.communal.visittimes.cache.VisitTimesCache;
import com.adc.da.communal.visittimes.service.VisitTimesService;
import com.adc.da.communal.visittimes.vo.FileVisitTimesVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * 部署初始化
 *
 * @author 韩磊
 * @version V1.0
 * @date 2019-05-21 11:36
 **/
@Component
public class VisitTimesInit implements CommandLineRunner {

    @Autowired
    private VisitTimesService visitTimesService;

    @Override
    public void run(String... strings) throws Exception {
        //获取当前文件访问次数，存入缓存
        List<Map<String,String>>   fileVisitTimesVOList =  visitTimesService.getAllFileVisitTimes();
        for(Map<String,String> fileVisitTimesMap : fileVisitTimesVOList){
            VisitTimesCache.put(fileVisitTimesMap.get("FURL"),Integer.parseInt(fileVisitTimesMap.get("TIMES")));
        }
    }
}
