package com.adc.da.communal.visittimes.service;

import com.adc.da.communal.visittimes.cache.VisitTimesCache;
import com.adc.da.communal.visittimes.dao.VisitTimesDao;
import com.adc.da.communal.visittimes.vo.FileVisitTimesVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author 韩磊
 * @version V1.0
 * @date 2019-05-21 11:57
 **/
@Service
public class VisitTimesService {

    @Autowired
    public VisitTimesDao visitTimesDao;

    /**
     * 获取TS_ADCBS_FILE_MANAGERMENT所有url及访问次数
     *
     * @param
     * @return java.util.List<com.adc.da.communal.visittimes.vo.FileVisitTimesVO>
     * @author 韩磊
     * @date 2019/5/21 12:59
     */
    public List<Map<String,String>>  getAllFileVisitTimes() {
        return visitTimesDao.getAllFileVisitTimes();
    }

    /**
     * 将点击的文件次数+1
     *
     * @param url
     * @return int
     * @author 韩磊
     * @date 2019/5/21 12:59
     */
    @Transactional(rollbackFor = Exception.class)
    public int saveVisitTimes(String url) {
        // 前0-8位是download_
        String key = url.substring(9);
        //缓存中key的次数+1
        int times = VisitTimesCache.add(key);
        //将+1之后的次数存入数据库
        return visitTimesDao.saveVisitTimes(key,times);
    }

}
